/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  This header file defines object code and should be turning into
an ordinary source file.  The only actual inclusion appears to be in
display_main.c.
****************************************************************************/


#ifndef RIA_CONSTANTS_H
#define RIA_CONSTANTS_H
char *FILE_MENU = "FILE MENU";
char *IMAGE_MENU = "IMAGE MENU";
char *ROI_MENU = "ROI MENU";
char *PIXEL_TYPE_ANALYSIS_STR = "PIXEL TYPE ANALYSIS";
char *GA_STR = "GA";
char *TA_STR = "TA";
char *CA_STR = "CA";
char *PIXEL_TYPE_GA_STR = "GA = TYPE : GROW REGION - Ctrl G";
char *PIXEL_TYPE_TA_STR = "TA = TYPE : THRESHOLDING - Ctrl T";
char *PIXEL_TYPE_CA_STR = "CA = COUNT VALUE ANAL - Ctrl C";
char *PIXEL_TYPE_GROW_REGION_ANALYSIS_STR = "PIXEL TYPE GROW REGION ANALYSIS";
char *PIXEL_TYPE_PARTITION_ANALYSIS_STR = "PIXEL TYPE PARTITION ANALYSIS";
char *CA_OPTIONS_STR "CA OPTIONS... - Sh O";
char *PROCESS_SLICE_SCANS_STR "PROCESS SLICE SCANS...- SH <> |";

char *SELECT_FNS_MENU = "OPEN IMAGE FILES... - <> O";
char *IMAGE_CONTRAST = "IMAGE CONTRAST... - U";
char *COLOR_PALLETTES = "COLOR PALLETTES - <> F12";

char *IMAGE_VIEW_FILTER = "IMAGE VIEW FILTER... - Sh V";
char *PIXEL_SELECTION = "PIXEL SELECTION... - <> P";
char *GROW_REGION = "GROW REGION... - <> T";
char *_3D = "3D - R";
char *CURSOR_MODE = "CURSORS - Sh ' ' || ' '";
char *MODIFY_IMAGE = "MODIFY IMAGE... Ctrl M";
char *RESIZE_IMAGE = "RESIZE IMAGE... Ctrl +";
char *RESIZE_TO_WID_SIZE = "RESIZE TO WID SIZE - =";
char *RESIZE_ZOOM_IN = "ZOOM IN - <> =";
char *RESIZE_ZOOM_OUT = "ZOOM OUT - +";
char *PRINT_OR_SAVE_IMAGE = "PRINT OR SAVE IMAGE - Ctrl P";
char *COLOR_EDITOR = "COLOR EDITOR... - Ctrl Sh F9";
char *WINDOW_MENU = "WINDOW MENU";
char *QUIT_AND_SAVE_FILE = "QUIT AND SAVE FILE - <> J";
char *EXIT_PROGRAM = "QUIT PROGRAM - <> Q";
char *HELP_STR = "HELP";

char *MENU_SEPARATOR = "   ------   = ";
char *HDR_SUFFIX = ".nhdr";
char *DAT_SUFFIX = ".ndat";
char *TXT_SUFFIX = ".ntxt";
char *BIN_SUFFIX = ".nbin";
char *NPAR_SUFFIX = ".npar";
char *NPCO_SUFFIX = ".npco";
char *PIXMAP_SUFFIX = ".pixmap";
char *COUNT_SUFFIX = ".count";
char *NO_ROI_STR = "*** NO ROI ***";
char *NO_PIXEL_TYPE_STR = "*** NO PIXEL TYPES DEFINED YET ***";
char *IMAGE_ANALYSIS_PROGRAM = "IMAGE ANALYSIS";
char *NO_EDITING = "NO EDITING !";

char *TISSUE_TYPES_DEFINED = "TISSUE TYPES DEFINED";

char *BATCH_FILE_MENU = "BATCH IMAGE FILES - Ctrl Sh F9";
char *MAIN_MENU_HELP = "GENERAL HELP - Ctrl Sh F10";
char *BEGINNER_HELP = "BEGINNER'S GUIDE - Ctrl Sh F11";

char *MAIN_MENU_HELP_FN = "main_menu.help";
char *DISPLAY_MENU_HELP_FN = "display_menu.help";
char *ANALYSIS_MENU_HELP_FN = "analysis_menu.help";
char *GET_DIR_FN_MENU_HELP_FN = "get_dir_fn_menu.help";
char *BEGINNER_HELP_FN = "beginner_guide.help";
char *COLOR_EDITOR_HELP_FN = "color_editor.help";
char *BATCH_HELP_FN = "batch.help";
char *TEXT_FORMAT_HELP_FN = "text_format.help";
char *PIXEL_SELECTION_HELP_FN = "pixel_selection.help";

/* GENERIC WINDOW MENU ITEM STRINGS */
char *SLICE_SELECTION_MENU = "SELECT SLICE... - F1";
char *PEN_ENABLED  = "PEN ENABLED - F2";
char *PEN_DISABLED = "PEN DISABLED - F2";

char *LABEL_ROI_AND_CURVE = "LABEL ROI & REGION - N";


char *SHOW_ROI = "SHOW SLICE ROIS - F4";
char *SHOW_PIXEL_TYPE_ROI = "SHOW PIXEL TYPE LABELS - F3";
char *MORE_ROI_OPTIONS = "MORE ROI OPTIONS... -Sh F8";
char *HIGHLIGHT_NEXT_CURVE = "NEXT REGION - F5/Sh MLEFT";
char *HIGHLIGHT_NEXT_ROI = "NEXT ROI   - F7/Sh MLEFT";
char *EDIT_NEXT_NEW_CURVE = "EDIT NEXT NEW REGION - F8";
char *EDIT_SCRATCH = "EDIT ***SCRATCH*** - <CR>";
char *ALL_WINS_CUR_ROI = "CUR ROI IN ALL WINS - F6";
char *SLICE_RECT = "SLICE RECT - Sh F9";
char *DELETE_ROI = "DELETE MENU...-Sh Ctrl F5.";
char *DRAW_LINK = "DRAW LINK... - Ctrl |";

char *BREAKER = "BREAKER OPTIONS... - Sh J" ;
char *BREAKER_ENABLE = "ENABLE BREAKER - Sh K";
char *BREAKER_LABEL = "BREAKER";
char *BREAKER_UNDO_LABEL = "BREAKER UNDO";
char *BREAK_IT = "BREAK CUR REGION - Sh L";
char *BREAK_UNDO = "UNDO - <Undo>";

char *CLIPBOARD = "CUT/COPY/PASTE";
char *CUT = "CUT - X / CUT";
char *CUT_APPEND = "CUT AND APPEND - Sh X / Ctrl CUT";
char *PASTE = "PASTE CUR REGION - V";
char *COPY = "COPY - C / COPY";
char *COPY_APPEND = "COPY AND APPEND - Sh C / Ctrl COPY";
char *CLIPBOARD_FIRST = "SHOW CLIPBOARD FIRST - <> F11";
char *CLIPBOARD_LAST = "SHOW CLIPBOARD LAST - <> F11";
char *PASTE_ALL "PASTE ALL - Paste";

char *BKG_PIXELS = "SET IMAGE BACKGROUND... - B";
char *HISTOGRAM_ROI = "HISTOGRAM - F9";
char *HISTOGRAM_OPTIONS = "HISTOGRAM OPTIONS...- Ctrl F9";
char *IMPORT_PIXEL_TYPE_MAP = "IMPORT PIXEL TYPE MAP - I";
char *HISTO_CURRENT_SLICE_1D = "1D-HISTOGRAM CURRENT SLICE - Ctrl F1";
char *HISTO_ALL_SLICES_1D = "1D-HISTOGRAM ALL SLICES - Ctrl F2";
char *HISTO_CURRENT_SLICE = "2D-HISTOGRAM CURRENT SLICE - Ctrl F3 / J";
char *HISTO_ALL_SLICES = "2D-HISTOGRAM ALL SLICES - Ctrl F4";
char *HISTO_SHOW = "SHOW HISTOGRAM - H";
char *HISTO_CLEAR = "CLEAR HISTOGRAM - K";
char *PARTITION_PIXEL_TYPES = "PARTITION ALL SLICES - F10";
char *SEGMENT_PIXEL_TYPES = "SEGMENT ALL SLICES - F10";
char *GROW_REGION_OPTIONS = "GROW REGION OPTIONS - Sh F10";
char *EDITED_PIXEL_TYPES = "ROI -> EDITED PIXEL TYPE - Ctrl F1";
char *PARTITIONED_PIXEL_TYPES = "ROI -> PARTITIONED - Ctrl F2";

char *ANALYSIS_STR = "ANALYZE ALL SLICES... - Sh A";
char *ANALYSIS_CUR_SLICE_STR = "ANALYZE CURRENT SLICE - A";
char *FORMAT_TEXT = "TEXT FORMAT...- Sh F12";
char *OUTPUT_ANALYSIS = "OUTPUT ANALYSIS";
char *SAVE_TEXT_TO_FILE = "SAVE TEXT FILE - Y";
char *SAVE_THEN_PRINT_TEXT = "SAVE THEN PRINT TEXT FILE - Ctrl F10";
char *PRINT_TEXT_TO_WINDOW = "DISPLAY TEXT FILE - T";
char *PRINT_ROIS_AND_PIXEL_TYPES = "DISPLAY ROIS & PIXEL TYPES - M";
char *SHOW_ROI_PIXEL_TYPE = "SHOW THE ROI PIXEL TYPE - ,";
char *DONT_SHOW_ROI_PIXEL_TYPE = "DON'T SHOW ROI PIXEL TYPE - ,";
char *SHOW_ALL_ROIS_PIXEL_TYPE = "SHOW ALL ROI PIXEL TYPES - .";
char *DONT_SHOW_ALL_ROIS_PIXEL_TYPE = "DON'T SHOW ALL ROI PIXEL TYPES - .";
char *SHOW_SLICE_PIXEL_TYPE = "SHOW SLICE PIXEL TYPE - /";
char *DONT_SHOW_SLICE_PIXEL_TYPE = "DON'T SHOW SLICE PIXEL TYPE - /";
char *FILTER_SHOW_TISSUES = "FILTER & SHOW TISSUES... - Sh B";
char *SHOW_TISSUE_WINS = "SHOW TISSUES IN WINDOWS - Sh N";

char *SEGMENT_SLICE = "SEGMENT CUR SLICE - F12";

char *SAVE_DATA = "SAVE/LOAD DATA... - <> S";
char *ANALYSIS_MENU_HELP = "HELP - <Help>";
char *REDEFINE_PIXEL_TYPE_ORDER = "PIXEL TYPE PRIORITY... - <> R";
char *OUTPUT_BIN = "SAVE IMAGE TYPE BINARY...";

char *SAVE_CUR_WIN_IMAGE = "SAVE CUR WINDOW IMAGE - Ctrl P";
/*
char *PRINT_CURRENT_IMAGE = "PRINT CURRENT IMAGE - Sh P";
char *PRINT_ALL_IMAGES = "PRINT ALL IMAGES";
*/

char *SAVE_DAT_FILE = "SAVE .ndat - S";
char *LOAD_FILE_SLICE_ROIS = "TRASH & LOAD GIVEN NDAT FILE SLICE ROIS";
char *RELOAD_SLICE_ROIS = "TRASH & RELOAD SAME NDAT FILE SLICE ROIS - <> K";
char *RELOAD_CUR_SLICE_ROIS = "TRASH & RELOAD CURRENT SLICE ROIS - <> M";
char *LOAD_DAT_FILE = "TRASH & LOAD FILE DATA - <> L";
char *ENTER_DAT_FN = "CHANGE .ndat FILE NAME - <> D";
char *FILE_INFO = "INFO - <> I";
char *ENTER_FILE_COMMENT = "EDIT FILE COMMENT - <> E";

char *OPTIONS = "ANALYZE IMAGE - Sh F1";
char *ALL_ECHO_WINS = "ALL ECHO WINDOWS - Sh W";
char *GET_NEW_WINS = "GET NEW WINDOWS... - W";
char *DUPLICATE_WINDOW  = "DUPLICATE WINDOW - Ctrl W";
char *SLAVE_WINDOW   = "SLAVE WIN/POSITIONING - <> M-LEFT";
char *GET_9_WINS = "9 WINDOWS - Sh Q";
char *GET_9_WINS_ALL_ECHOES = "9 WINDOWS (ALL ECHOES) - Q";
char *GET_12_WINS = "12 WINDOWS - Sh E";
char *GET_12_WINS_ALL_ECHOES = "12 WINDOWS (ALL ECHOES) - E";
char STACK_SLICE_OR_SCAN "STACK SLICE/SCAN - <> Z";
char *MAGNIFY_PIXEL = "MAGNIFY PIXEL... - Sh F2";
char *EXIT_DISPLAY_WINDOW = "QUIT CURRENT WINDOW... - Ctrl Sh F6";
char *EXIT_MULTIPLE_DISPLAY_WINDOW = "QUIT MULTIPLE WINDOWS - Ctrl Sh F7";
char *EXIT_STACK_WINDOWS = "QUIT STACK/GROUP WINDOWS - Ctrl Sh F8";

char *DISPLAY_MENU_HELP = "HELP Sh <Help>";
char *IMAGE_ENHANCEMENT = "IMAGE ENHANCEMENT- Ctrl Y";
char *EDGE_DETECTION = "EDGE DETECTION... - Ctrl E";
char *POLARITY = "POLARITY";

/* magnify pixel menu items */
char *MAGNIFY_WINDOW = "MAGNIFY +2 - <> M-MIDDLE/<> <0..9>";
char *MAGNIFY_SHRINK_WINDOW  = "SHRINK -2 - <> M-RIGHT";
char *MAGNIFY_LAST_WINDOW = "MAGNIFY TO LAST DIMENSION - ESC";
char *MAGNIFY_DEFAULT_WINDOW = "MAGNIFY TO DEFAULT DIMENSION - Tab";



/* GENERIC PEN TYPE MENU ITEM STRINGS */
char *PEN_FREE_AND_CLOSED = "FREE-HAND POLYGON - F";
char *PEN_FREE_AND_CLOSED_LABEL = "<F>FREE-POLYGON";
char *PEN_POLYGON = "POLYGON - P";
char *PEN_POLYGON_LABEL = "<P>POLYGON";
char *PEN_LINE = "LINES - L";
char *PEN_LINE_LABEL = "<L>LINE";
char *PEN_FREE = "FREE-HAND REGIONS - ;";
char *PEN_FREE_LABEL = "<Y>FREE";
char *PEN_POINT_MODE = "POINT MODE - :";
char *PEN_POINT_MODE_LABEL = "<:>POINT";

char *PEN_CIRCLE = "CIRCLE - O";
char *PEN_CIRCLE_LABEL = "<O>CIRCLE";

char *PEN_ELLIPSE = "ELLIPSE - [";
char *PEN_ELLIPSE_LABEL = "<[>ELLIPSE";

char *PEN_RECT = "RECTANGLE - ]";
char *PEN_RECT_LABEL = "<]>RECT";

/* GENERIC DISPLAY OPTION MENU ITEM STRINGS */
char *HIDE_SHOW_ALL_ROIS_OF_CURRENT_SLICE = "HIDE/SHOW ALL ROIS - Sh Z";
char *HIDE_ALL_ROIS_OF_CUR_SLICE_BUT_CUR = "HIDE/SHOW ALL ROIS BUT CUR- Z";
char *FILL_ROIS = "SHADE ROIS - Sh R";
char *DONT_FILL_ROIS = "DON'T SHADE ROIS - Sh R";
char *DISPLAY_PEN_ENABLED_LABEL = "DISPLAY PEN ENABLED LABEL";
char *DONT_DISPLAY_PEN_ENABLED_LABEL = "DON'T DISPLAY PEN ENABLED LABEL";
char *DISPLAY_THE_PIXEL_POSITION = "DISPLAY THE PIXEL POSITION";
char *DONT_DISPLAY_THE_PIXEL_POSITION = "DON'T DISPLAY THE PIXEL POSITION";
char *OUT_OF_BOUND_ROIS = "OUT OF BOUND ROIS";
char *MAKE_ROI_CONVEX = "MAKE CUR ROI CONVEX";

/* GENERIC DELETE_ROI MENU ITEM STRINGS */
char *DELETE_CURRENT_POINT_STR = "DELETE CURRENT POINT - DELETE/BACKSPACE";
char *DELETE_CURRENT_CURVE_STR = "DELETE CURRENT REGION - Ctrl Sh F1";
char *DELETE_CURRENT_ROI_STR = "DELETE CURRENT ROI - Ctrl Sh F2";
char *DELETE_ALL_ROIS_STR = "DELETE ALL ROIS - Ctrl Sh F3";
char *DELETE_ALL_FILE_ROIS_STR = "DELETE ALL FILE ROIS - Ctrl Sh F4";


char *_3D_FILE_MENU = "IMAGE OPTIONS...- N";
char *_3D_IMAGE_OPTIONS = "3D IMAGE OPTIONS - N";
char *_3D_MENU = "3D PLANE OPTIONS - P";
char *_3D_PLANE_OPTIONS = "PLANE OPTIONS... - P";
char *_3D_MORE_PLANE_OPTIONS = "MORE PLANE OPTIONS... - I";
char *_3D_RESIZE_IMAGE = "RESIZE 3D IMAGE... - :";
char *_3D_CO_REGISTRATION = "CO-REGISTRATION... - M";
char *_3D_ROI_TYPE_MENU = "3D ROIS & PIXEL TYPES";
char *_3D_ROIS_PIXEL_TYPES = "ROIS & PIXEL TYPES...";
char *_3D_SPLIT_ROIS_MENU = "3D SPLIT ROIS...";
char *_3D_SPLIT_ROIS = "SPLIT ROIS...";
char *_3D_DISPLAY_MENU = "3D DISPLAY OPTIONS";
char *_3D_DISPLAY_OPTIONS = "DISPLAY OPTIONS...";
char *_3D_SAVE_MENU = "SAVE 3D IMAGE... - S";
char *_3D_PARAM_MENU = "PARAMETER... -Sh P";

char *_3D_CURSOR_MENU = "CURSORS - Sh ' ' || ' '";
char *_3D_CUT_MODE = "90 DEGREE CUT";
char *_3D_ANGLE_CUT_MODE = "ANGLE CUT";
char *_3D_ROTATE_VERTICAL_MODE = "VERTICAL ROTATE";
char *_3D_ROTATE_HORIZONTAL_MODE = "HORIZONTAL ROTATE";
char *_3D_ROTATE_MODE = "OBSOLUTE ROTATE";

char *_3D_ORIENTATION = "ORIENTATION - F11";
char *_3D_0_ROTATION = "0 ROT. - R12/Sh-R12";
char *_3D_90_ROTATION = "90 ROT. - R8/Sh-R8";
char *_3D_180_ROTATION = "180 ROT. - R10/Sh-R10";
char *_3D_270_ROTATION = "270 ROT. - R14/Sh-R14";
char *_3D_Y_X_REFLECTION = "\\ REFLECTION - R7";
char *_3D_YX_REFLECTION = "/ REFLECTION - R9";
char *_3D_NO_REFLECTION = "NO REFLECTION - R11";
char *_3D_Y_REFLECTION = "| REFLECTION - R13";
char *_3D_X_REFLECTION = "--- REFLECTION - R15";
char *FLIP_PLANE_CLOCKWISE = "FLIP PLANE CLOCKWISE - -";
char *FLIP_PLANE_ANTI_CLOCKWISE = "FLIP PLANE CLOCKWISE - +";

char *_3D_LAST_PLANE = "LAST PLANE - Ins";

char *_3D_BUTTON_STR = "3D";

char *ANAL = "ANAL";
char *WIN = "WIN";

char *IMAGE_FUSION_MENU = "IMAGE FUSION...-Sh F";
char *OVERLAY_IMAGE "OVERLAY IMAGE";
char *OVERLAYED_BY_WID "OVERLAYED BY WID [ALL ECHOES] - [Sh]<> N";
char *DELETE_OVERLAY "DELETE [STACK] OVERLAY - [Ctrl]<> G";
char *SHOW_HIDE_OVERLAY "SHOW/HIDE [STACK] OVERLAY - [Ctrl]<> H";

char *OVERLAY_IMAGE = "OVERLAY IMAGE";
char *OVERLAYED_BY_WID = "OVERLAYED BY WID - ]";
char *OVERLAYED_BY_ALL_ECHO_WID = "OVERLAYED BY ALL ECHO WID - ~";
char *DELETE_OVERLAY = "DELETE OVERLAY - }";
char *DELETE_STACK_OVERLAY = "DELETE STACK OVERLAY - ~";
char *SHOW_HIDE_OVERLAY = "SHOW/HIDE OVERLAY - <> H";
char *SHOW_HIDE_STACK_OVERLAY = "SHOW/HIDE STACK OVERLAY - [Ctrl]<> H";

char *CHANNEL_MENU = "CHANNEL TO...-Ctrl<MRIGHT>";
char *IMAGE_HISTOGRAM_WINDOW = "HISTOGRAM WINDOW -<> W";
char *MAKE_WINDOW_CURRENT = "MAKE WINDOW CURRENT...-<> W";
char *CLOSE_WIN = "CLOSE WINDOW";
char *CLOSE_STACK_WINS = "CLOSE STACK WINDOWS";
char *CLOSE_FILE_WINS = "CLOSE FILE WINDOWS";
char *OPEN_WIN = "OPEN WINDOW";
char *OPEN_STACK_WINS = "OPEN STACK WINDOWS";
char *OPEN_FILE_WINS = "OPEN FILE WINDOWS";


char *OPERATION_ABORTED = "Operation Aborted !!!";
char *PLEASE_WAIT = "Please wait !!!";
char *OK = "OK !!!";
char *MEMORY_ERR = "PROBABLY MEMORY ERROR !!!";
char *GRADIENT = "GRADIENT";
char *GRADIENTX = "GRADIENT X";
char *GRADIENTY = "GRADIENT Y";
char *SEGMENTED = " : SEGMENTED";
char *EDITED = " : EDITED";
char *PARTITIONED = " : PARTITIONED";
char *MARKER = " : MARKER";
char *EMPTY = " : EMPTY";

char *ALL_SLICES_LABEL = "ALL SLICES";
char *ALL_ROIS_LABEL = "ALL ROIS";
char *CUR_ROI_LABEL = "ROI";
char *CUR_CURVE_LABEL = "CUR REGION";

char *TRANS_ROI = "MOVE/ROTATE/RESIZE ROI... - <>F1";
char *ALL_SLICES_ITEM_LABEL = "ALL SLICES - <>F2";
char *ALL_ROIS_ITEM_LABEL = "ALL ROIS - <>F3";
char *CUR_ROI_ITEM_LABEL = "ROI - <>F4";
char *CUR_CURVE_ITEM_LABEL = "CUR REGION - <>F5";
char *SLICE_ROI_PRIOR = "<< SLICE ROIS - <>F6";
char *SLICE_ROI_NEXT = ">> - <>F7";

char *CURSOR_DEFAULT_LABEL = "DEFAULT - KP1";
char *CURSOR_PEN_LABEL = "PEN - KP2";
char *CURSOR_DELETE_ROI_MODE = "DELETE ROI MODE - KP3";
char *CURSOR_MOVE_ROI_LABEL = "MOVE ROI - KP6";
char *CURSOR_RESIZE_ROI_LABEL = "RESIZE ROI - KP5";
char *CURSOR_ROTATE_ROI_LABEL = "ROTATE ROI - KP6";

char *PIXEL_TYPES_TO_HISTO_ROIS = "TYPES TO HISTO-ROIS - Sh T";
char *CUR_SLICE_TYPES_TO_HISTO_ROIS = "CUR SLICE TYPES TO HISTO-ROIS - Sh T";
char *ALL_SLICE_TYPES_TO_HISTO_ROIS = "ALL SLICE TYPES TO HISTO-ROIS - Sh Y";

char *CUR_ROI_TO_HISTO_ROI = "CUR ROI TO HISTO-ROI - Sh H";
char *CUR_ROI_TO_HISTO_POINTS = "CUR ROI TO HISTO-ROI POINTS";
char *CUR_ROI_TO_HISTO_CONVEX_REGION = "CUR ROI TO HISTO-ROI - CONVEX REGION";
char *CUR_ROI_TO_HISTO_RANGE_REGION = "CUR ROI TO HISTO-ROI - RANGE REGION";
char *HISTO_ROI_TO_SLICE_ROI = "CUR HISTO ROI TO SLICE-ROI - Ctrl B";

char *WHOLE_SLICE_STR = "WHOLE SLICE";
char *CUR_ROI_STR = "CUR ROI";
char *CUR_CURVE_STR = "CUR REGION";
char *ALL_ROIS_STR = "ALL ROIS";


char *HISTO_ROI = "HISTO-ROI";
char *SLICE_ROI = "SLICE-ROI";


char *YES = " YES !";
char *NO = " NO !";
char *WILL_CONTINUE = "WILL CONTINUE !";
char *NON_BACKGROUND = "NON-BACKGROUND";
char *HISTO_NON_BACKGROUND = "HISTO-NON-BACKGROUND";

char *SLICE_RECT_ROI = "SLICE-RECT";

char *_3D_PT1_LABEL = "3D-PT1";
char *_3D_PT2_LABEL = "3D-PT2";
char *_3D_PT3_LABEL = "3D-PT3";

char *ROI_INVISIBLE = "ROI-";

char *NO_OTHER_FILE_WID = "NO OTHER FILE WIDs !!!";
char *RECO_REGISTER_WITH_WID = "RECO-REGISTER WITH WID";
char *SCRATCH_STR = "***SCRATCH***";


#endif RIA_CONSTANTS_H
