/****************************************************************************
num_v1.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: num_v1.c,v 1.6 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

/* Are these needed? 
#include <math.h>
#include <stdio.h>
*/

#include <string.h>

#include "nria_lib.h"


/*-----------------------------------------------------------------------
hex - ???

 num is in the range of 0..15
-----------------------------------------------------------------------*/

char 
hex(num)
 unsigned long num;
{
 if (num < 10)
     return (char) ((int) '0' + num);
 else
     switch (num) {
	 case 10 : return 'A';
	 case 11 : return 'B';
	 case 12 : return 'C';
	 case 13 : return 'D';
	 case 14 : return 'E';
	 default : return 'F';
	 };
}


/*-----------------------------------------------------------------------
byte_hex - ???
-----------------------------------------------------------------------*/

char *
byte_hex(num)
 unsigned long num;
{
 static char str[3] = {'\0','\0','\0'};
 unsigned long rem;

 memset(str,48,2);
 if (num == 0) return str;
 rem = num % 16;
 str[1] = hex(rem);
 num /= 16;
 str[0] = hex(num);
 return str;
}


/*-----------------------------------------------------------------------
short_hex - ???
-----------------------------------------------------------------------*/

char *
short_hex(num)
 unsigned short num;
{
 static char str[5];
 unsigned short rem;
 int lcv;

 memset(str,48,4);
 str[4] = '\0';
 if (num == 0) return str;
 for (lcv = 0; lcv < 4; lcv++)
    {rem = num % 16;
     str[3 - lcv] = hex((unsigned long) rem);
     num /= 16;
     if (num == 0) return str;
    }
 return str;
}


/*-----------------------------------------------------------------------
long_hex - ???
-----------------------------------------------------------------------*/

char *
long_hex(num)
 unsigned long num;
{
 static char str[9];
 unsigned long rem;
 int lcv;

 memset(str,48,8);
 str[8] = '\0';
 if (num == 0) return str;
 for (lcv = 0; lcv < 8; lcv++)
    {rem = num % 16;
     str[7 - lcv] = hex(rem);
     num /= 16;
     if (num == 0) return str;
    }
 return str;
}


/*-----------------------------------------------------------------------
buf_hex - ???
-----------------------------------------------------------------------*/

char *
buf_hex(buf,num_elems)
 unsigned char *buf;
 unsigned long num_elems;
{
 static char str[511];
 int lcv,indx;

 if (num_elems == 0)
    {str[0] = '\0';
     return str;}
 if (num_elems > 255) num_elems = 255;
 printf("numelem = %ld\n",num_elems);
 str[num_elems * 2] = '\0';
 for (indx = lcv = 0; lcv < num_elems; lcv += 1,indx += 2)
    {
     str[indx] = hex((unsigned long) (buf[lcv] / 16));
     str[indx + 1] = hex((unsigned long) (buf[lcv] % 16));
    }
 return str;
}
