
#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include "lib/mri_format.h"
#include "lib/segment.h"
/*
csh lslicegr.com
cc -c slicegr.c
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 9 9 2 1 1 0 10 10
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 9 9 2 1 0 0 10 10
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 0 0
slicegr /omri/test/q2prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 0 0
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 0 16 15 15
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 0 28 35 25 35 25 35 25
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 0 28 50 20 50 20 50 20
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 0 15 50 15 50 15 50 15 50 15

slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 0 15 15
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 13 1 1 0
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 0
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 16 15 15
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 28 35 25 35 25 35 25
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 28 50 20 50 20 50 20
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 1 1 15 50 15 50 15 50 15 50 15

slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 0 0
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 0 16 15 15
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 0 28 35 25 35 25 35 25
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 0 28 50 20 50 20 50 20
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 0 15 50 15 50 15 50 15 50 15

slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 1 0
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 1 16 15 15
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 1 28 35 25 35 25 35 25
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 1 28 50 20 50 20 50 20
slicegr /omri/test/q1prt2mri10051ar1.nhdr /omri/test "" "" 12 12 2 1 15 50 15 50 15 50 15 50 15
*/
/*
#define PRINT(x) x; fflush(stdout);
#define TIME(x) x; fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define PRT(x)
#define PRINT(x)
#define TRACE(x)
#define TIME(x)

/*
init_all_stair_case_rec(all_stairs)
free_all_stair_case_rec(all_stairs)
pr_all_stair_case_rec(all_stairs)
init_all_val_density_rec(allvals)
free_all_val_density_rec(allvals)
pr_all_val_density_rec(allvals)
sort_val_density_rec(val1,val2)
setup_all_val_density_rec(_2d,fx,fy,lx,ly,slice_roi,allvals)
sort_peak_indx_rec_proc(peak_indx1,peak_indx2)
setup_all_stair_case_rec(all_stairs,allvals)
peak_ok(stair,peak_indx,allvals)
setup_percent_stair_case_rec(all_stairs,allvals,white_percent,gray_percent,apply)
setup_stair_case_rec(all_stairs,allvals)
sort_stair_case_rec(stair1,stair2)
setup_coord_params(roi,_2d1,_2d2,fx,fy,lx,ly,lbval,ubval,which_buf)
setup_grow_region_params(_2d1,_2d2,fx,fy,lx,ly,suffix,slice_roi,allvals,all_stairs,which_buf)
quadrant(_2d1,_2d2,fx,fy,lx,ly,suffix,slice_roi,white_percent,gray_percent,apply,which_buf)
grow_region_2_echo_params(imgfid,hdr,histo,percents,apply,option,this_slice_num,which_buf)
setup_background(histo)
process_params(fn,ndatfn,percents,apply,option,which_buf,start_slice_num,end_slice_num,order)
prog_usage(argc,argv)
get_params(argc,argv,dirfn,fn_patt,ndatdir,prefix,
           start_slice_num,end_slice_num,apply,option,which_buf,percents,order)
main(argc,argv)
*/
unsigned long NumberOfSliceCuts();

static unsigned char _EdgeBit1[] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

#define Q1 0
#define Q2 1
#define Q3 2
#define Q4 3
#define WHOLE 4
#define GROW_REGION_1 5

#define LESS_THAN_LEFT 1
#define GREATER_THAN_LEFT 2
#define LESS_THAN_RIGHT 4
#define GREATER_THAN_RIGHT 8
#define LEFT_EMPTY 0x0010
#define RIGHT_EMPTY 0x0020
struct stair_case_rec
   {
    unsigned short status;
    long lb,ub,max,total_pixels;
   };

struct peak_indx_rec
   {
    long total_pixels,indx;
   };

struct all_stair_case_rec
   {
    unsigned long total_peak_indxs,num_peak_indxs;
    struct peak_indx_rec *peak_indxs;
    unsigned long total_stairs,num_stairs;
    struct stair_case_rec *stairs;
   };

#define VAL_ALREADY_USED 1
struct val_density_rec
   {
    unsigned char status;
    long val;
    unsigned long total_pixels;
   };

struct all_val_density_rec
   {
    unsigned short status;
    long max_stair_cases;
    unsigned long total_pixels;
    float mean;
    unsigned long total_vals,num_vals;
    struct val_density_rec **vals;
   };

struct roi_rec *get_roi();

init_all_stair_case_rec(all_stairs)
 struct all_stair_case_rec *all_stairs;
{
 all_stairs->total_peak_indxs = all_stairs->num_peak_indxs = 0;
 all_stairs->peak_indxs = NULL;
 all_stairs->total_stairs = all_stairs->num_stairs = 0;
 all_stairs->stairs = NULL;
}

free_all_stair_case_rec(all_stairs)
 struct all_stair_case_rec *all_stairs;
{
 if (all_stairs->total_peak_indxs > 0)
    {c_free(all_stairs->peak_indxs);}
 if (all_stairs->total_stairs > 0)
    {c_free(all_stairs->stairs);}
 init_all_stair_case_rec(all_stairs);
}

pr_all_stair_case_rec(all_stairs)
 struct all_stair_case_rec *all_stairs;
{
 unsigned long lcv;

 printf("pr_all_stair_case_rec...total_peak_indxs = %d num_peak_indxs = %d\n",
         all_stairs->total_peak_indxs,all_stairs->num_peak_indxs);
 for (lcv = 0; lcv < all_stairs->num_peak_indxs; lcv++)
    printf("%d) total_pixels = %d indx = %d\n",lcv,
          all_stairs->peak_indxs[lcv].total_pixels,all_stairs->peak_indxs[lcv].indx);

 printf("...total_stairs = %d num_stairs = %d\n",
         all_stairs->total_stairs,all_stairs->num_stairs);
 for (lcv = 0; lcv < all_stairs->num_stairs; lcv++)
    printf("%d) status = %x lb = %d ub = %d  max = %d  total_pixels = %d\n",
               lcv,(unsigned long) all_stairs->stairs[lcv].status,
               all_stairs->stairs[lcv].lb,all_stairs->stairs[lcv].ub,
               all_stairs->stairs[lcv].max,all_stairs->stairs[lcv].total_pixels);

 printf("pr_all_stair_case_rec...end\n");
}

init_all_val_density_rec(allvals)
 struct all_val_density_rec *allvals;
{
 allvals->status = 0;
 allvals->max_stair_cases = 3;
 allvals->total_pixels = 0;
 allvals->mean = .0;
 allvals->total_vals = 0;
 allvals->num_vals = 0;
 allvals->vals = NULL;
}

free_all_val_density_rec(allvals)
 struct all_val_density_rec *allvals;
{
 unsigned long lcv;

 if (allvals->total_vals > 0)
    {for (lcv = 0; lcv < allvals->total_vals; lcv++)
        c_free(allvals->vals[lcv]);
     c_free(allvals->vals);}
 init_all_val_density_rec(allvals);
}

pr_all_val_density_rec(allvals)
 struct all_val_density_rec *allvals;
{
 unsigned long lcv;

 printf("pr_all_val_density_rec...total = %d num = %d mean = %f total_pixels = %d\n",
    allvals->total_vals,allvals->num_vals,allvals->mean,allvals->total_pixels);
 for (lcv = 0; lcv < allvals->num_vals; lcv++)
    printf("%d) val = %d  total = %d\n",lcv,allvals->vals[lcv]->val,
              allvals->vals[lcv]->total_pixels);
 printf("pr_all_val_density_rec...end\n");
}

sort_val_density_rec(val1,val2)
 struct val_density_rec **val1,**val2;
{
 if ((*val1)->val > (*val2)->val) return 1;
 if ((*val1)->val < (*val2)->val) return -1;
 return 0;
}

setup_all_val_density_rec(_2d,fx,fy,lx,ly,slice_roi,allvals)
 struct buf_2d_rec *_2d;
 int fx,fy,lx,ly;
 struct slice_roi_rec *slice_roi;
 struct all_val_density_rec *allvals;
{
 int err;
 long row,col,lcv,num,indx;
 struct val_density_rec dval,*the_val,*val_ptr;

 val_ptr = &dval;
 err = NO_ERROR;
 for (row = fy; row <= ly; row++)
    for (col = fx; col <= lx; col++)
       {
        dval.val = get_1d_buf_value(_2d->buf[row],col,_2d->pixel_depth);
        if (dval.val != 0)
           {if (allvals->num_vals == 0) indx = 0;
              else
               {
                if (obj_binary_search(allvals->vals,allvals->num_vals,
                    sizeof(*(allvals->vals)),&val_ptr,sort_val_density_rec,&indx) == NO_ERROR)
                   {allvals->vals[indx]->total_pixels += 1;
                    continue;}
               }
            if (allvals->num_vals >= allvals->total_vals)
               {if ((err = get_handle(&(allvals->vals),&(allvals->total_vals),256,
                    (size_t) sizeof(**(allvals->vals)))) != NO_ERROR)
                   break;}
            the_val = allvals->vals[allvals->num_vals];
            the_val->val = dval.val;
            the_val->total_pixels = 1;
            the_val->status = 0;
/*
            PRT(printf("total_vals = %d num_vals = %d indx = %d\n",
                     allvals->total_vals,allvals->num_vals,indx);)
*/
            for (num = lcv = allvals->num_vals; lcv > indx; lcv = num)
               {num -= 1;
                allvals->vals[lcv] = allvals->vals[num];}
            allvals->vals[indx] = the_val;
            allvals->num_vals += 1;
           }
        if (err != NO_ERROR) break;
       }
 if (err == NO_ERROR) 
    {for (lcv = 0; lcv < allvals->num_vals; lcv++)
        allvals->total_pixels += allvals->vals[lcv]->total_pixels;
     allvals->mean = (float) allvals->total_pixels / (float) allvals->num_vals;
    }
 return err;
}

sort_peak_indx_rec_proc(peak_indx1,peak_indx2)
 struct peak_indx_rec *peak_indx1,*peak_indx2;
{
 if (peak_indx1->total_pixels < peak_indx2->total_pixels) return 1;
 if (peak_indx1->total_pixels > peak_indx2->total_pixels) return -1;
 return 0;
}

setup_all_stair_case_rec(all_stairs,allvals)
 struct all_stair_case_rec *all_stairs;
 struct all_val_density_rec *allvals;
{
 int err;
 long lcv,cnt;

 all_stairs->num_peak_indxs = 0;
 for (lcv = 0; lcv < allvals->num_vals; lcv++)
    if ((float) allvals->vals[lcv]->total_pixels >= allvals->mean)
       all_stairs->num_peak_indxs += 1;
 if (all_stairs->num_peak_indxs == 0) return NO_ERROR;
 if ((err = get_ptr(&(all_stairs->peak_indxs),&(all_stairs->total_peak_indxs),
         all_stairs->num_peak_indxs,(size_t) sizeof(*(all_stairs->peak_indxs)))) != NO_ERROR)
    return err;
 for (cnt = 0,lcv = 0; lcv < allvals->num_vals; lcv++)
    if ((float) allvals->vals[lcv]->total_pixels >= allvals->mean)
       {
        all_stairs->peak_indxs[cnt].total_pixels = allvals->vals[lcv]->total_pixels;
        all_stairs->peak_indxs[cnt++].indx = lcv;}
 PRT(printf("setup_all_stair_case_rec num_peak_indxs = %d\n",all_stairs->num_peak_indxs))

 qsort(all_stairs->peak_indxs,all_stairs->num_peak_indxs,
           (size_t) sizeof(*(all_stairs->peak_indxs)),sort_peak_indx_rec_proc);

 return NO_ERROR;
}

peak_ok(stair,peak_indx,allvals)
 struct stair_case_rec *stair;
 struct peak_indx_rec *peak_indx;
 struct all_val_density_rec *allvals;
{
 long lcv,cnt,indx,num,total_pixels,max_stair_cases;
 int yes;

 indx = peak_indx->indx;
 if (allvals->vals[indx]->status & VAL_ALREADY_USED) return 0;
 stair->status = 0;
 stair->max = peak_indx->total_pixels;
 stair->lb = stair->ub = peak_indx->indx;
 max_stair_cases = allvals->max_stair_cases;
 if (indx > 0) 
    {for (lcv = indx - 1; lcv >= 0; )
        {if (allvals->vals[lcv]->status & VAL_ALREADY_USED) return 0;
         total_pixels = allvals->vals[lcv]->total_pixels;
         if (total_pixels > peak_indx->total_pixels) return 0;
         stair->lb = lcv;
         for (yes = 0,cnt = lcv - 1,num = 1;
                    (cnt >= 0) && (num < max_stair_cases); num++)
            {if (allvals->vals[cnt]->status & VAL_ALREADY_USED) return 0;
             if (total_pixels < allvals->vals[cnt]->total_pixels)
                {yes = 1;
                 break;}
             total_pixels = allvals->vals[cnt]->total_pixels;
             cnt--;
            }
         if (yes) lcv = cnt;
           else
            {stair->lb = cnt + 1;
             break;
            }
        }
    }
 if (indx < allvals->num_vals) 
    {for (lcv = indx + 1; lcv < allvals->num_vals; )
        {if (allvals->vals[lcv]->status & VAL_ALREADY_USED) return 0;
         total_pixels = allvals->vals[lcv]->total_pixels;
         if (total_pixels > peak_indx->total_pixels) return 0;
         stair->ub = lcv;
         for (yes = 0,cnt = lcv + 1,num = 1;
                  (cnt < allvals->num_vals) && (num < max_stair_cases); num++)
            {if (allvals->vals[cnt]->status & VAL_ALREADY_USED) return 0;
             if (total_pixels < allvals->vals[cnt]->total_pixels)
                {
                 yes = 1;
                 break;}
             total_pixels = allvals->vals[cnt]->total_pixels;
             cnt++;
            }
         if (yes) lcv = cnt;
           else
            {stair->ub = cnt - 1;
             break;
            }
        }
    }
 stair->total_pixels = 0;
 for (lcv = stair->lb; lcv <= stair->ub; lcv++)
    {stair->total_pixels += allvals->vals[cnt]->total_pixels;
     allvals->vals[cnt]->status |= VAL_ALREADY_USED;}
 return 1;
}

setup_percent_stair_case_rec(all_stairs,allvals,white_percent,gray_percent,apply)
 struct all_stair_case_rec *all_stairs;
 struct all_val_density_rec *allvals;
 float white_percent,gray_percent;
 int apply;
{
 int err;
 long lcv,cnt,total;

 if ((err = get_ptr(&(all_stairs->stairs),&(all_stairs->total_stairs),2,
                    (size_t) sizeof(*(all_stairs->stairs)))) != NO_ERROR)
    return err;
 all_stairs->num_stairs = 2;
 all_stairs->stairs[0].status = 0;
 all_stairs->stairs[0].max = 0;
 all_stairs->stairs[0].total_pixels = 0;
 all_stairs->stairs[0].lb = 0;

 all_stairs->stairs[1].status = 0;
 all_stairs->stairs[1].max = 0;
 all_stairs->stairs[1].total_pixels = 0;
 all_stairs->stairs[1].ub = allvals->num_vals - 1;
 TRACE(printf("*** total pixels = %d\n",allvals->total_pixels))
 if (apply == 1)
    {
     total = allvals->total_pixels * white_percent;
     for (lcv = all_stairs->stairs[0].lb; lcv < allvals->num_vals; lcv++)
        {total -= allvals->vals[lcv]->total_pixels;
         all_stairs->stairs[0].total_pixels += allvals->vals[lcv]->total_pixels;
         if (total <= 0) break;
        }
     total = allvals->total_pixels * white_percent;
     all_stairs->stairs[0].ub = lcv;
     TRACE(printf("white_percent = %f --> percent-pixels = %d  #pixels = %d   lb = %d ub = %d\n",
               white_percent,total,
               all_stairs->stairs[0].total_pixels,
               all_stairs->stairs[0].lb,all_stairs->stairs[0].ub))

     total = allvals->total_pixels * gray_percent;
     for (lcv = allvals->num_vals - 1; lcv >= 0; lcv--)
        {total -= allvals->vals[lcv]->total_pixels;
         all_stairs->stairs[1].total_pixels += allvals->vals[lcv]->total_pixels;
         if (total <= 0) break;
        }
     all_stairs->stairs[1].lb = lcv;
     total = allvals->total_pixels * gray_percent;
     TRACE(printf("gray_percent = %f --> percent-pixels = %d  #pixels = %d   lb = %d ub = %d\n",
               gray_percent,total,
               all_stairs->stairs[1].total_pixels,
               all_stairs->stairs[1].lb,all_stairs->stairs[1].ub))
    }
   else
    {
     total = allvals->num_vals * white_percent;
     all_stairs->stairs[0].ub = total;
     for (lcv = all_stairs->stairs[0].lb; lcv < all_stairs->stairs[0].ub; lcv++)
        all_stairs->stairs[0].total_pixels += allvals->vals[lcv]->total_pixels;
     TRACE(printf("white_percent = %f --> #pixels = %d   lb = %d ub = %d\n",
               white_percent,all_stairs->stairs[0].total_pixels,
               all_stairs->stairs[0].lb,all_stairs->stairs[0].ub))

     total = allvals->num_vals * gray_percent;
     all_stairs->stairs[1].lb = allvals->num_vals - total;
     for (lcv = all_stairs->stairs[1].lb; lcv < all_stairs->stairs[1].ub; lcv++)
        all_stairs->stairs[1].total_pixels += allvals->vals[lcv]->total_pixels;
     TRACE(printf("gray_percent = %f --> #pixels = %d   lb = %d ub = %d\n",
               white_percent,all_stairs->stairs[1].total_pixels,
               all_stairs->stairs[1].lb,all_stairs->stairs[1].ub))
    }
 return NO_ERROR;
}

setup_stair_case_rec(all_stairs,allvals)
 struct all_stair_case_rec *all_stairs;
 struct all_val_density_rec *allvals;
{
 int err;
 long lcv;
 struct stair_case_rec stair;

 for (lcv = 0; lcv < all_stairs->num_peak_indxs; lcv++)
    {if (peak_ok(&stair,&(all_stairs->peak_indxs[lcv]),allvals))
        {
         if (all_stairs->num_stairs >= all_stairs->total_stairs)
            {if ((err = get_ptr(&(all_stairs->stairs),&(all_stairs->total_stairs),10,
                    (size_t) sizeof(*(all_stairs->stairs)))) != NO_ERROR)
                return err;}
         all_stairs->stairs[all_stairs->num_stairs] = stair;
         all_stairs->num_stairs += 1;
        }
    }
 return NO_ERROR;
}

sort_stair_case_rec(stair1,stair2)
 struct stair_case_rec *stair1,*stair2;
{
 if (stair1->lb > stair2->lb) return 1;
 if (stair1->lb < stair2->lb) return -1;
 return 0;
}

setup_coord_params(roi,_2d1,_2d2,fx,fy,lx,ly,lbval,ubval,which_buf)
 struct roi_rec *roi;
 struct buf_2d_rec *_2d1,*_2d2;
 int fx,fy,lx,ly;
 long lbval,ubval;
 int which_buf;
{
 int err;
 long row,col,x,y;
 unsigned short status;
 long total_pixels;
 struct buf_2d_rec *the_2d;

 TRACE(printf("QUADRANT...LEFT = %d  TOP = %d  RIGHT = %d  LEFT = %d\n",fx,fy,lx,ly))
 err = NO_ERROR;
 total_pixels = 0;
 if (which_buf == 1) 
    {for (row = fy; row <= ly; row++)
        for (col = fx; col <= lx; col++)
           {
            x = get_1d_buf_value(_2d1->buf[row],col,_2d1->pixel_depth);
            if ((x >= lbval) && (x <= ubval))
               {y = get_1d_buf_value(_2d2->buf[row],col,_2d2->pixel_depth);
                if ((err = EnterPtsIntoRoiRec(roi,DRAW_POINT,&status,NULL,0,1,
                     (double) x,(double) y)) != NO_ERROR)
                   return err;
                total_pixels += 1;
               }
            }
    }
   else 
    {for (row = fy; row <= ly; row++)
        for (col = fx; col <= lx; col++)
           {
            y = get_1d_buf_value(_2d2->buf[row],col,_2d2->pixel_depth);
            if ((y >= lbval) && (y <= ubval))
               {x = get_1d_buf_value(_2d1->buf[row],col,_2d1->pixel_depth);
                if ((err = EnterPtsIntoRoiRec(roi,DRAW_POINT,&status,NULL,0,
                       1,(double) x,(double) y)) != NO_ERROR)
                   return err;
                total_pixels += 1;
               }
            }
    }
 TRACE(printf("TOTAL PIXEL IN QUADRANT...= %d\n",total_pixels))
 return NO_ERROR;
}

setup_grow_region_params(_2d1,_2d2,fx,fy,lx,ly,suffix,slice_roi,allvals,all_stairs,which_buf)
 struct buf_2d_rec *_2d1,*_2d2;
 int fx,fy,lx,ly;
 char *suffix;
 struct slice_roi_rec *slice_roi;
 struct all_val_density_rec *allvals;
 struct all_stair_case_rec *all_stairs;
 int which_buf;
{
 int err;
 long lbval,ubval,lbval1,ubval1;
 struct roi_rec white_roi,gray_roi,*roi;
 char *white,*gray;

 white = gray = NULL;
 PRT(printf("setup_grow_region_params...1\n"))
 if (((err = concat_strs(&white,2,"white matter",suffix)) != NO_ERROR) ||
     ((err = concat_strs(&gray,2,"gray matter",suffix)) != NO_ERROR))
    {c_free(white);
     c_free(gray);
     return err;
    }
 init_roi_rec(&white_roi,NULL);
 init_roi_rec(&gray_roi,NULL);
 white_roi.label = white;
 gray_roi.label = gray;
 PRT(printf("setup_grow_region_params...white = %s  gray = %s\n",white,gray))

 lbval = allvals->vals[0]->val;
 ubval1 = allvals->vals[allvals->num_vals - 1]->val;
 if (all_stairs->num_stairs == 1)
    {ubval = allvals->vals[all_stairs->stairs[0].ub]->val;
     lbval1 = allvals->vals[all_stairs->stairs[0].lb]->val;
    }
   else
    {qsort(all_stairs->stairs,all_stairs->num_stairs,
              (size_t) sizeof(*(all_stairs->stairs)),sort_stair_case_rec);
     ubval = allvals->vals[all_stairs->stairs[0].ub]->val;
     lbval1 = allvals->vals[all_stairs->stairs[all_stairs->num_stairs - 1].lb]->val;
    }
 PRT(printf("\nwhite = %s lbval = %d ubval = %d     gray = %s lbval = %d ubval = %d\n",
             white,lbval,ubval,gray,lbval1,ubval1))
 if (((err = setup_coord_params(&white_roi,_2d1,_2d2,fx,fy,lx,ly,lbval,ubval,which_buf))
             == NO_ERROR) &&
     ((err = setup_coord_params(&gray_roi,_2d1,_2d2,fx,fy,lx,ly,lbval1,ubval1,which_buf))
             == NO_ERROR) &&
     ((err = JoinRoiToSliceRoiRec(slice_roi,&white_roi,1,1.0,1.0,NULL,NULL,NULL))
             == NO_ERROR))
    err = JoinRoiToSliceRoiRec(slice_roi,&gray_roi,1,1.0,1.0,NULL,NULL,NULL);
 free_roi_rec(&white_roi);
 free_roi_rec(&gray_roi);
 PRT(printf("setup_grow_region_params err = %d\n\n",err))
 return err;
}

quadrant(_2d1,_2d2,fx,fy,lx,ly,suffix,slice_roi,white_percent,gray_percent,apply,which_buf)
 struct buf_2d_rec *_2d1,*_2d2;
 int fx,fy,lx,ly;
 char *suffix;
 struct slice_roi_rec *slice_roi;
 float white_percent,gray_percent;
 int apply;
 int which_buf;
{
 int err;
 struct all_val_density_rec allvals;
 struct all_stair_case_rec all_stairs;
 struct buf_2d_rec *the_2d;

 init_all_val_density_rec(&allvals);
 PRT(printf("quadrant suffix = %s fx = %d  fy = %d  lx = %d  ly = %d w = %f g = %f\n",
        suffix,fx,fy,lx,ly,white_percent,gray_percent);)
 if (which_buf == 1) the_2d = _2d1;
   else the_2d = _2d2;
 if (((err = setup_all_val_density_rec(the_2d,fx,fy,lx,ly,slice_roi,&allvals)) == NO_ERROR) &&
     (allvals.num_vals > 0))
    {/*pr_all_val_density_rec(&allvals);*/
     init_all_stair_case_rec(&all_stairs);
     if ((err = setup_percent_stair_case_rec(&all_stairs,&allvals,
                 white_percent,gray_percent,apply)) == NO_ERROR)
        {
         PRT(pr_all_stair_case_rec(&all_stairs);)
         err = setup_grow_region_params(_2d1,_2d2,fx,fy,lx,ly,suffix,slice_roi,
                       &allvals,&all_stairs,which_buf);
        }
/*
     if ((err = setup_all_stair_case_rec(&all_stairs,&allvals)) == NO_ERROR)
        {if (((err = setup_stair_case_rec(&all_stairs,&allvals)) == NO_ERROR) &&
             (all_stairs.num_stairs > 0))
            {
             pr_all_stair_case_rec(&all_stairs);
             err = setup_grow_region_params(_2d1,_2d2,fx,fy,lx,ly,suffix,slice_roi,
                       &allvals,&all_stairs,which_buf);
            }
        }
*/
     free_all_stair_case_rec(&all_stairs);
    }

 free_all_val_density_rec(&allvals);
 return err;
}

grow_region_2_echo_params(imgfid,hdr,histo,percents,apply,option,this_slice_num,which_buf)
 FILE *imgfid;
 struct hdr_rec *hdr;
 struct histo_params_rec *histo;
 float percents[10];
 int apply,option,this_slice_num,which_buf;
{
 int err;
 long slice_num,cnt,indx,lcv,histo_dimx,histo_dimy,pixel_depth,next,num_slices;
 struct buf_2d_rec _2d1,_2d2,*ptr_2d;
 struct hdr_scan_entry_rec *cur1,*cur2;

 num_slices = NumberOfSliceCuts(&(hdr->data_info));
 if (this_slice_num == 0)
    {slice_num = num_slices;
     if (slice_num % 2) slice_num = (slice_num / 2) + 1;
       else slice_num = slice_num / 2;
     printf("*** MIDDLE SLICE# = %d\n",slice_num);
    }
   else if ((this_slice_num > 0) && (this_slice_num <= num_slices))
    {slice_num = this_slice_num;
     /* printf("*** SLICE# = %d\n",slice_num);*/}
   else
    {
     printf("*** Illegal SLICE# = %d  not in the range of 1 - %d\n",this_slice_num,num_slices);
     exit(1);}
 slice_num = (slice_num - 1) * hdr->data_info.num_echoes;
 init_buf_2d_rec(&_2d1);
 init_buf_2d_rec(&_2d2);
 PRT(printf("grow_region_2_echo_params....1\n"))
 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_MULTI_D);
 PRT(printf("grow_region_2_echo_params....2\n"))
 cur1 = &(hdr->scans[slice_num]);
 cur2 = &(hdr->scans[slice_num + 1]);
 PRT(printf("grow_region_2_echo_params....2..1\n"))
 if (((err = setup_buf_2d_rec(&_2d1,hdr->data_info.dimx,hdr->data_info.dimy,
             hdr->data_info.pixel_depth_bits,0)) != NO_ERROR) ||
     ((err = setup_buf_2d_rec(&_2d2,hdr->data_info.dimx,hdr->data_info.dimy,
             hdr->data_info.pixel_depth_bits,0)) != NO_ERROR))
    printf("Error setting the slice...err = %d\n",err);
  else if (((err = RdCurSlice(imgfid,cur1,&_2d1)) != NO_ERROR) || 
           ((err = RdCurSlice(imgfid,cur2,&_2d2)) != NO_ERROR))
    printf("Error reading the slice...err = %d\n",err);
 if (err != NO_ERROR)
    {free_buf_2d_rec(&_2d1);
     free_buf_2d_rec(&_2d2);
     return err;}

 _2d1.minval_set = _2d2.minval_set = hdr->data_info.min_pixel;
 _2d1.maxval_set = _2d2.maxval_set = hdr->data_info.max_pixel;
 _2d1.status4 |= BUF_MIN_MAX_SET;
 _2d2.status4 |= BUF_MIN_MAX_SET;
 PRT(printf("grow_region_2_echo_params....3\n"))


 if (((err = Scale2dPixels(&_2d1,&_2d1,(double) .0,
           (double) (histo_dimx - 1),0,(double) .0,(double) .0,0)) == NO_ERROR) &&
     ((err = Scale2dPixels(&_2d2,&_2d2,(double) .0,
           (double) (histo_dimy - 1),0,(double) .0,(double) .0,0)) == NO_ERROR))
    {
     if ((err == NO_ERROR) && (option & _EdgeBit1[Q1]))
        err = quadrant(&_2d1,&_2d2,0,0,_2d1.dimx / 2 - 1,_2d1.dimy / 2 - 1,
            ":Q1",&(histo->slice_roi_win_2d.slice_roi),
            percents[0],percents[1],apply,which_buf);

     if ((err == NO_ERROR) && (option & _EdgeBit1[Q2]))
        err = quadrant(&_2d1,&_2d2,
            _2d1.dimx / 2 - 1,0,_2d1.dimx - 1,_2d1.dimy / 2 - 1,
            ":Q2",&(histo->slice_roi_win_2d.slice_roi),
            percents[2],percents[3],apply,which_buf);
     if ((err == NO_ERROR) && (option & _EdgeBit1[Q3]))
        err = quadrant(&_2d1,&_2d2,
            0,_2d1.dimy / 2 - 1,_2d1.dimx / 2 - 1,_2d1.dimy - 1,
            ":Q3",&(histo->slice_roi_win_2d.slice_roi),
            percents[4],percents[5],apply,which_buf);
     if ((err == NO_ERROR) && (option & _EdgeBit1[Q4]))
        err = quadrant(&_2d1,&_2d2,
            _2d1.dimx / 2 - 1,_2d1.dimy / 2 - 1,_2d1.dimx - 1,_2d1.dimy - 1,
            ":Q4",&(histo->slice_roi_win_2d.slice_roi),percents[6],percents[7],
            apply,which_buf);
     if (option & _EdgeBit1[WHOLE])
        err = quadrant(&_2d1,&_2d2,0,0,_2d1.dimx - 1,_2d1.dimy - 1,
            "",&(histo->slice_roi_win_2d.slice_roi),
            percents[8],percents[9],apply,which_buf);
    }

 free_buf_2d_rec(&_2d1);
 free_buf_2d_rec(&_2d2);
/*
 if (err == NO_ERROR)
    if (this_slice_num == 0)
       printf("*** Chosen MIDDLE SLICE# = %d\n",slice_num / 2 + 1);
      else printf("*** Chosen SLICE# = %d\n",slice_num / 2 + 1);
*/
 PRT(printf("grow_region_2_echo_params...end...err = %d\n",err))
 return err;
}

setup_background(histo)
 struct histo_params_rec *histo;
{
 struct roi_rec *roi;
 struct slice_roi_rec *slice_roi;
 long lcv;
 unsigned short status;
 int err;

 PRT(printf("setup_background...1\n"))
 free_histo_bkg_rec(&(histo->bkg));
 slice_roi = &(histo->slice_roi_win_2d.slice_roi);
 free_slice_roi_rec(slice_roi);
 if ((err = get_ptr(&(histo->bkg.bkgs),&(histo->bkg.num_bkgs),
              4,(size_t) sizeof(*(histo->bkg.bkgs)))) != NO_ERROR) 
    return err;
 PRT(printf("setup_background...2\n"))
 for (lcv = 0; lcv < 4; lcv++)
    histo->bkg.bkgs[lcv] = 0;
 if ((err = init_roi_rec(&(histo->bkg.roi),
                      BACKGROUND_PIXEL_TYPE_STR)) == NO_ERROR)
    {histo->bkg.roi.status |= ROI_USER_MARKED;
     if (((err = EnterPtsIntoRoiRec(&(histo->bkg.roi),
             DRAW_POLYGON,&status,NULL,1,2,(double) .0,(double) .0,
             (double) .0,(double) .0)) == NO_ERROR) &&
         ((err = JoinRoiToSliceRoiRec(slice_roi,
                 &(histo->bkg.roi),0,1.0,1.0,NULL,NULL,NULL)) == NO_ERROR))
        if ((roi = get_roi(slice_roi,BACKGROUND_PIXEL_TYPE_STR)) != NULL)
           roi->status |= HISTO_EDITED_ROI;
    }
 PRT(printf("setup_background...err = %d\n",err))
 return err;
}

process_params(fn,ndatfn,percents,apply,option,which_buf,start_slice_num,end_slice_num,order)
 char *fn,*ndatfn;
 float percents[10];
 int apply,option,which_buf,start_slice_num,end_slice_num;
 struct strs_rec *order;
{
 struct hdr_rec hdr;
 struct output_hdr_rec ndathdr;
 int err;
 struct histo_params_rec histo;
 struct pixel_type_rec pixel_type;
 int slice_num;

 struct slice_roi_rec *slice_rois;
 long total_slice_rois;
 struct text_output_analysis_group_rec *groups;
 unsigned_int num_groups;
 struct output_text_format_rec format;
 struct count_analysis_rec count;

 FILE *imgfid;
 char *reason,*imgfn,*temp,*pixfn;

 PRT(printf("process_params...fn = %s  ndatfn = %s\n",fn,ndatfn))
 init_hdr_rec(&hdr);
 temp = imgfn = NULL;
 if (((err = cp_str(&temp,fn)) != NO_ERROR) ||
     ((err = drop_suffix(temp)) != NO_ERROR) ||
     ((err = concat_strs(&imgfn,2,temp,".img")) != NO_ERROR))
    {printf("Error constructing fn = %s...err = %d\n",fn,err);
     c_free(temp);
     c_free(imgfn);
     return err;
    }
 c_free(temp);

 if ((err = rd_the_hdr(fn,&hdr)) != NO_ERROR)
    {printf("Error reading the hdr file = %s...err = %d\n",fn,err);
     c_free(imgfn);
     return err;
    }
    
 PRT(printf("process_params...imgfn = %s\n",imgfn))
 if (hdr.data_info.num_echoes != 2)
    {printf("CANCEL...Sorry %s is not a 2-echo image set...\n",fn);
     c_free(imgfn);
     return CANCEL;
    }
 if ((start_slice_num <= 0) || (end_slice_num <= 0))
    {start_slice_num = 1;
     end_slice_num = NumberOfSliceCuts(&(hdr.data_info));}

 if ((imgfid = fopen(imgfn,"r")) == NULL)
    {file_access(imgfn,4,NULL,&reason);
     printf("Error opening the img file = %s...reason = %s\n",imgfn,reason);
     free_hdr_rec(&hdr);
     c_free(reason);
     c_free(imgfn);
     return FILE_ACCESS_ERROR;}
 PRT(printf("process_params...ndatfn = %s\n",ndatfn))

 if ((err = RdTheNdatFields(ndatfn,&ndathdr,&slice_rois,&total_slice_rois,
        &histo,&pixel_type,&groups,&num_groups,&format,&count)) != NO_ERROR)
    {if (err == FILE_ACCESS_ERROR)
        {err = NO_ERROR;
         /*
         file_access(ndatfn,14,NULL,&reason);
         printf("Error opening the ndat file = %s...reason = %s\n",ndatfn,reason);
         */}
       else printf("Error reading the ndat file...ndatfn = %s err = %d\n",ndatfn,err);
    }
 PRT(printf("process_params...3\n"))

 if ((err == NO_ERROR) && ((err = setup_background(&histo)) == NO_ERROR))
    {for (slice_num = start_slice_num; slice_num <= end_slice_num; slice_num++)
        {printf("Processing slice#%d\n",slice_num);fflush(stdout);
         if ((err = grow_region_2_echo_params(imgfid,&hdr,&histo,percents,apply,option,
               slice_num,which_buf)) != NO_ERROR)
            {printf("Error setting up the grow region params...%s err = %d\n",fn,err);
             break;}
         if (option & _EdgeBit1[GROW_REGION_1])
            if ((err = err = GrowRegion2Echo(imgfid,&hdr,&histo,&pixel_type,order,
                    slice_num - 1,slice_num - 1)) != NO_ERROR)
               {printf("Error segmenting the slices...%s err = %d\n",fn,err);
                break;}

        }
     if (err == NO_ERROR)
        {
         TRACE(printf("before WrRiaNdatFile...\n"))

          if (option & _EdgeBit1[GROW_REGION_1])
            {pixfn = NULL;
             if (((err = cp_str(&pixfn,ndatfn)) == NO_ERROR) &&
                 ((err = drop_suffix(pixfn)) == NO_ERROR))
                {TRACE(printf("before wr_file_pixmap...\n"))
                 err = wr_file_pixmap("",pixfn,PIXMAP_SUFFIX,&pixel_type,&reason);
                 if (err != NO_ERROR)
                    printf("Error writing the pixmap = %s%s...reason = %s\n",pixfn,
                            PIXMAP_SUFFIX,reason);
                }
               else printf("Memory error...err = %d\n",err);
              c_free(pixfn);
             }
          if (err == NO_ERROR) 
             if (WrRiaNdatFile(ndatfn,
                        &ndathdr,slice_rois,total_slice_rois,
                        &histo,&pixel_type,
                        groups,num_groups,&format,&count) != NO_ERROR)
                printf("Error saving %s !!!\n",ndatfn);
               else printf("...%s updated!!!\n",ndatfn);
         }
    }
 PRT(printf("before free_ndat_fields...\n"))
 free_ndat_fields(&ndathdr,slice_rois,total_slice_rois,
              &histo,&pixel_type,groups,num_groups,&format,&count);

 PRT(printf("process_params...end...err = %d\n",err))
 free_hdr_rec(&hdr);
 c_free(imgfn);
 fclose(imgfid);
 return err;
}


prog_usage(argc,argv)
 int argc;
 char *argv[];
{
 if (argc < 11)
    {printf("\nUsage : %s 2-echo-nhdr-fn ndat-dir ndat-prefix pixel_types.order\n",
                     argv[0]);
     printf("             start-slice_num end-slice_num apply PROTON_OR_T2 grow_region option\n");
     printf("            [[q-lb%% q-ub%%] [q1-lb%% q1-ub%%] [q2-lb%% q2-ub%%] [q3-lb%% q3-ub%%] [q4-lb%% q4-ub%%]]\n");
     printf("if either start-slice_num <= 0 or end-slice_num <= 0, do region-growing on the\n");
     printf("   whole file.\n");
     printf("where if apply =\n");
     printf("    1 : apply percents on total pixels\n");
     printf("    2 : apply percents on total pixel values\n");
     printf("where if PROTON_OR_T2 =\n");
     printf("    1 : use the proton image\n");
     printf(" else : use the T2 image\n");
     printf("where if grow_region =\n");
     printf("    0   : setup and save the grow region parameters only\n");
     printf("  non-0 : setup and save the grow region parameters & grow the region\n");
     printf("where if option == 0\n");
     printf("      : the next 2 q-lb%% & ub%% will be taken as the parameters\n");
     printf("        for the whole slice if they are present.  Otherwise,\n");     
     printf("        lb = ub = 25% are assumed !!!\n");
     printf("where if option & \n");
     printf("    1 : q1-lb%% & ub%% for the 1st quadrant are present in the parameters\n");
     printf("    2 : q2-lb%% & ub%% for the 2nd quadrant are present in the parameters\n");
     printf("    4 : q3-lb%% & ub%% for the 2nd quadrant are present in the parameters\n");
     printf("    8 : q4-lb%% & ub%% for the 2nd quadrant are present in the parameters\n");
     printf("   16 : q-lb%% & ub%% for the whole slice are present in the parameters\n");
     printf("  Note : the values of option = 1,2,4,8 & 16 can be added together,\n");
     printf("         in other words to be used together.  If they are not present altogether,\n");
     printf("         lb = 25% & ub = 25% are assumed for the whole slice\n");
     printf("\n");

     printf("Example 1 : %s mri10257a.nhdr /omri/ndat abc \"\" 10 10 1 0 0 0\n",argv[0]);
     printf("   Input : mri10257a.nhdr\n\n");
     printf("         : mri10257a.img\n\n");
     printf("         : /omri/ndat/abcmri10257a.ndat\n\n");
     printf("         : since pixel_types.order == \"\", /exusr/mri/ria/pixel_types.order is\n");
     printf("           assumed !!!\n");
     printf("         : start-slice_num = 10, & end-slice_num = 10\n");
     printf("         : since apply = 1, apply percents on total pixels\n");
     printf("         : since PROTON_OR_T2 = 0, use the T2 image\n");
     printf("         : since grow_region = 0, setup and save the grow region parameters only\n");
     printf("         : since no lb & ub parameters present,\n");
     printf("           lb = 25%% & ub = 25%% are assumed for the whole slice\n");
     printf("   Output : histogram of /omri/ndat/abcmri10257a.ndat updated\n\n");
     printf("\n");
     printf("Example 2 : %s \"/amri/*.nhdr\" /omri/ndat abc \"\" 0 0 2 1 1 16 5 5\n",argv[0]);
     printf("   Input : /amri/*.nhdr\n\n");
     printf("         : /amri/*.img\n\n");
     printf("         : /omri/ndat/abc*.ndat\n\n");
     printf("         : since pixel_types.order == \"\", /exusr/mri/ria/pixel_types.order is\n");
     printf("           assumed !!!\n");
     printf("         : since start-slice_num = 0, or end-slice_num = 0, apply to all slices\n");
     printf("         : since apply = 2, apply percents on total pixel values\n");
     printf("         : since PROTON_OR_T2 = 1, use the PROTON image\n");
     printf("         : since grow_region = 1, grow the region\n");
     printf("         : since option & 16, lb = 5%% & ub = 5%% for the whole slice\n");
     printf("\n");
     printf("   Output : histogram of /omri/ndat/abc*.ndat updated\n\n");
     printf("\n");
     printf("Example 3 : %s \"/amri/*.nhdr\" /omri/ndat abc \"\" 0 0 1 1 1 16 15 15\n",argv[0]);
     printf("   Input : /amri/*.nhdr\n\n");
     printf("         : /amri/*.img\n\n");
     printf("         : /omri/ndat/abc*.ndat\n\n");
     printf("         : since pixel_types.order == \"\", /exusr/mri/ria/pixel_types.order is\n");
     printf("           assumed !!!\n");
     printf("         : since start-slice_num = 0, or end-slice_num = 0, apply to all slices\n");
     printf("         : since apply = 1, apply percents on total pixels\n");
     printf("         : since PROTON_OR_T2 = 1, use the PROTON image\n");
     printf("         : since grow_region = 1, grow the region\n");
     printf("         : since option & 16, lb = 15%% & ub = 15%% for the whole slice\n");
     printf("\n");
     printf("   Output : histogram of /omri/ndat/abc*.ndat updated\n\n");
     printf("\n");
     printf("Example 4 : %s \"/amri/*.nhdr\" /omri/ndat abc \"\" 0 0 2 1 1 15 25 15 25 25 25 25 25 25\n",argv[0]);
     printf("   Input : /amri/*.nhdr\n\n");
     printf("         : /amri/*.img\n\n");
     printf("         : /omri/ndat/abc*.ndat\n\n");
     printf("         : since pixel_types.order == \"\", /exusr/mri/ria/pixel_types.order is\n");
     printf("           assumed !!!\n");
     printf("         : since start-slice_num = 0, or end-slice_num = 0, apply to all slices\n");
     printf("         : since apply = 2, apply percents on total pixel values\n");
     printf("         : since PROTON_OR_T2 = 1, use the PROTON image\n");
     printf("         : since grow_region = 1, grow the region\n");
     printf("         : since option & 1, option & 2, option & 4, and option & 8,\n");
     printf("         : lb%% & ub%% for the 4 quadrants are present\n");
     printf("   Output : histogram of /omri/ndat/abc*.ndat updated\n\n");
     printf("\n");
     printf("Note : if you use '*' in the file specification, please\n");
     printf("       enclose that file specification by double quotes.\n");
     exit(1);}
}

get_params(argc,argv,dirfn,fn_patt,ndatdir,prefix,
           start_slice_num,end_slice_num,apply,option,which_buf,percents,order)
 int argc;
 char *argv[];
 char **dirfn,**fn_patt,**ndatdir,**prefix;
 int *apply,*option,*which_buf,*start_slice_num,*end_slice_num;
 float percents[10];
 struct strs_rec *order;
{
 int err,is_grow_region;
 long lcv,cnt,num;
 char *fn;

 *dirfn = (char *) locate_dirfn(argv[1]);
 if (*dirfn == NULL) 
    if ((err = cp_str(dirfn,".")) != NO_ERROR) 
    {printf("Error = %d\n",err);
     exit(1);}
 drop_dirfn(argv[1]);
 if (((err = cp_str(fn_patt,argv[1])) != NO_ERROR) ||
     ((err = cp_str(ndatdir,argv[2])) != NO_ERROR) ||
     ((err = cp_str(prefix,argv[3])) != NO_ERROR))
    {printf("Error = %d\n",err);
     exit(1);}
 if (get_strlen(argv[4]) == 0) fn = "/exusr/mri/ria/pixel_types.order";
   else fn = argv[4];

 if ((err = rd_ascii_file_strs_to_strs_rec(fn,order,0)) != NO_ERROR)
    {printf("Error reading the pixel type order = %s...err = %d\n",fn,err);
     exit(1);}

 sscanf(argv[5],"%d",start_slice_num);
 sscanf(argv[6],"%d",end_slice_num);
 if ((*start_slice_num > *end_slice_num) && (*start_slice_num >= 0) &&
     (*end_slice_num >= 0))
    {printf("Sorry, start_slice_num = %d < end_slice_num = %d!!!\n",
                 *start_slice_num,*end_slice_num);
     exit(1);}

 sscanf(argv[7],"%d",apply);
 sscanf(argv[8],"%d",which_buf);
 if (*which_buf == 1) printf("...PROTON image will be used for statistics\n");
    else printf("...T2 image will be used for statistics\n");
 sscanf(argv[9],"%d",&is_grow_region);
 sscanf(argv[10],"%d",option);

#define PERCENT_START 11
 if ((*apply != 1) && (*apply != 2))
    {
     printf("Sorry, ambiguos apply methods = %d!!!\n",*apply);
     printf("apply must be 1 or 2 !!!\n");
     exit(1);}
 if ((argc == PERCENT_START) || (*option == 0))
    {*option = _EdgeBit1[WHOLE];
     if (argc >= 12)
        {sscanf(argv[PERCENT_START],"%f",&(percents[8]));
         sscanf(argv[PERCENT_START + 1],"%f",&(percents[9]));
         printf("Whole slice : lb = %.2f%%  and  ub = %.2f%%\n",
                 percents[8],percents[9]);
         percents[8] /= 100.0;
         percents[9] /= 100.0;}
       else
        {printf("Whole slice : lb = 25%%  and  ub = 25%% are assumed\n");
         percents[8] = percents[9] = .25;}
     for (lcv = 0; lcv <= 7; lcv++)
        percents[lcv] = .0;
     if (is_grow_region)
        *option |= _EdgeBit1[GROW_REGION_1];
     return NO_ERROR;
    }
 for (num = 0,lcv = 0; lcv < 5; lcv++)
    if (*option & _EdgeBit1[lcv]) num += 2;
 if (num == 0)
    {printf("Sorry, ambiguos options = %d  %x!!!\n",*option,*option);
     printf("Which paramters are set are not indicated in the option !!!\n");
     exit(1);}
 if ((num + PERCENT_START) != argc)
    {printf("Sorry, incorrect # of parameters !!!\n",*option,*option);
     printf("# of lb & ub parameters shoud be %d !!!\n",num);
     exit(1);}

 for (num = PERCENT_START,cnt = 0,lcv = 0; lcv < 5; lcv++,cnt += 2)
    {
     if (*option & _EdgeBit1[lcv]) 
        {sscanf(argv[num],"%f",&(percents[cnt]));
         percents[cnt] /= 100.0;
         num += 1;
         sscanf(argv[num],"%f",&(percents[cnt+1]));
         percents[cnt+1] /= 100.0;
         num += 1;
        }
       else percents[cnt] = percents[cnt+1] = .0;
    }
 printf("\n");
 for (cnt = 0,lcv = 0; lcv < 5; lcv++,cnt += 2)
    if (*option & _EdgeBit1[lcv])
       {if (lcv == WHOLE) printf("Whole slice : ");
          else printf("Quadrant%d : ",lcv + 1);
        printf(" lb%% = %.2f  ub%% = %.2f\n",percents[cnt] * 100.0,percents[cnt+1] * 100.0);
       }
 if ((*option & _EdgeBit1[WHOLE]) && ((*option & 0x000f) == 0x000f))
    {printf("Parameters for the whole slice will not be used since all the 4\n");
     printf("quadrants are present !!!\n");
     *option &= ~_EdgeBit1[WHOLE];
    }
 if (is_grow_region)
    *option |= _EdgeBit1[GROW_REGION_1];

 return NO_ERROR;
}

main(argc,argv)
 int argc;
 char *argv[];
{
 int rater;
 int err;
 char **fns,*dirfn,*fn_patt,*fn,*temp,*ndatfn,*ndatdir,*prefix;
 int apply,option,start_slice_num,end_slice_num,which_buf;
 unsigned int num_fns;
 unsigned long lcv;
 struct strs_rec order,errlog;
 float percents[10];

 prog_usage(argc,argv);
 init_strs_rec(&order);
 if ((err = get_params(argc,argv,&dirfn,&fn_patt,&ndatdir,&prefix,
     &start_slice_num,&end_slice_num,&apply,&option,&which_buf,percents,&order)) != NO_ERROR)
    {printf("Error getting parameters...err = %d\n",err);
     exit(err);}
 if ((err = get_fns(dirfn,NULL,0,0,NULL,&fns,&num_fns,1,fn_patt,
         NULL,0,0,NULL)) != NO_ERROR)
    exit(err);

 err = CANCEL;
 if (num_fns == 0)
    {printf("Sorry...No file names...\n");
    }
   else
    {
     printf("\n");
     init_strs_rec(&errlog);
     for (lcv = 0; lcv < num_fns; lcv++)
        {fn = temp = ndatfn = NULL;
         if (((err = concat_strs(&fn,3,dirfn,"/",fns[lcv])) == NO_ERROR) &&
             ((err = cp_str(&temp,fn)) == NO_ERROR) &&
             ((err = drop_suffix(temp)) == NO_ERROR) &&
             ((err = drop_dirfn(temp)) == NO_ERROR) &&
             ((err = concat_strs(&ndatfn,5,ndatdir,"/",prefix,temp,".ndat")) == 
                       NO_ERROR))
            {printf("%d) processing %s & %s\n",lcv,fn,ndatfn);
             if ((err = process_params(fn,ndatfn,percents,apply,option,which_buf,
                        start_slice_num,end_slice_num,&order)) != NO_ERROR)
                {printf("...%d) ERROR processing %s & %s...err = %d\n",
                       lcv,fn,ndatfn,err);
                 add_str_to_strs_rec(&errlog,fn);
                 err = NO_ERROR;}
            }
         c_free(fn);
         c_free(temp);
         c_free(ndatfn);
         if (err != NO_ERROR)
            {
             printf("...%d) ERROR processing %s/%s\n",lcv,dirfn,fns[lcv]);
             printf("Quiting...\n");
             break;}
        }
     if (errlog.num_strs > 0)
        {printf("\nErrors occurred when processing the following files :-\n");
         for (lcv = 0; lcv < errlog.num_strs; lcv++)
            printf("%d) %s\n",lcv,errlog.strs[lcv]);
         printf("\n");}
     free_strs_rec(&errlog);
    }
 c_free(dirfn);
 c_free(fn_patt);
 c_free(prefix);
 c_free(ndatdir);
 free_strs_rec(&order);
 exit(err);
}
