/****************************************************************************
fusion.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: fusion.c,v 1.8 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "common.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT11(x) x; fflush(stdout);
#define PRT12(x) x; fflush(stdout);
#define PRT14(x) x; fflush(stdout);
#define PRT15(x) x; fflush(stdout);
#define PRT12(x) x; fflush(stdout);
#define PRT13(x) x; fflush(stdout);
#define PRT17(x) x; fflush(stdout);
#define PRT18(x) x; fflush(stdout);
#define PRT16(x) x; fflush(stdout);
#define PRT17(x) x; fflush(stdout);
#define PRT19(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x) 
#define PRT1(x) 
#define PRT2(x) 
#define PRT3(x) 
#define PRT6(x) 
#define PRT7(x) 
#define PRT8(x) 
#define PRT9(x) 
#define PRT10(x) 
#define PRT11(x) 
#define PRT14(x) 
#define PRT15(x) 
#define PRT13(x) 
#define PRT12(x) 
#define PRT17(x) 
#define PRT18(x) 
#define PRT17(x) 
#define PRT16(x) 
#define PRT19(x) 




/* Functions defined in this file */
int OrColorData(struct buf_2d_rec *dest, struct intensity_rec *intensity,
    struct color_screen_rec *src1, long dleft, long dtop, long dright,
    long dbottom, long dx, long dy, struct color_screen_rec *src2, long sleft,
    long stop, long sright, long sbottom);
int SrcOnlyColorData1(struct buf_2d_rec *dest,
    struct intensity_rec *intensity, struct color_screen_rec *src1,
    struct color_screen_rec *src2, long sleft, long stop, long sright,
    long sbottom);
int BlendColorData(struct buf_2d_rec *dest, struct intensity_rec *intensity,
    struct color_screen_rec *src1, long dleft, long dtop, long dright,
    long dbottom, long dx, long dy, struct color_screen_rec *src2, long sleft,
    long stop, long sright, long sbottom, int blend_select);
int WinFusionIt(struct image_display_window *win, struct buf_2d_rec *dest,
    struct int_bound_rec *dst_bound, struct color_screen_rec *src1,
    struct color_screen_rec *src2, struct int_bound_rec *src2_bound,
    unsigned long method);
int WinDynamicForwardFusion1(struct image_display_window *win,
    int has_been_transformed);
int WinDynamicBackwardFusion(struct image_display_window *win);
int WinMoveFusion2dToSuperimpose2d(struct image_display_window *win);
int WinImageFusion1(struct image_display_window *win,
    struct int_bound_rec *src_bound, struct int_bound_rec *dst_bound, int opr,
    char *src_wid);
int TransformFusionSrc(struct img_buf_rec *img);
int WinRotateFusion(struct image_display_window *win, double fl_angle);



/****************
 PRT13(printf("OrColorData...1\n"))
 PRT11(
          for (lcv5 = 0; lcv5 < src2->color_datas[0]->num_color_indxs; lcv5++)
             printf("%d) %d\n",lcv5,
                    (unsigned long) src2->color_datas[0]->color_indxs[lcv5]);

      printf("src2...\n");
      for (lcv2 = 0; lcv2 < src2->num_color_datas; lcv2++)
         {printf("%d) %d lab = %s  %d %d mid = %d lb = %d ub = %d\n",lcv2,
           src2->color_datas[lcv2]->num_color_indxs,
           src2->color_datas[lcv2]->scale.label,
           src2->color_datas[lcv2]->scale.first,
           src2->color_datas[lcv2]->scale.first_visible,
           src2->color_datas[lcv2]->scale.mid_value,
           src2->color_datas[lcv2]->scale.lb,
           src2->color_datas[lcv2]->scale.ub);
         }
     )
 PRT11(
       if ((src2->color_datas[0]->scale.first ==
                  src1->color_datas[0]->scale.first) &&
           (src2->color_datas[0]->scale.num_colors ==
            src1->color_datas[0]->scale.num_colors))
          {for (lcv5 = 0; lcv5 < src2->color_datas[0]->num_color_indxs; lcv5++)
              if (src1->color_datas[0]->color_indxs[lcv5]  != 
                  src2->color_datas[0]->color_indxs[lcv5])
                 {
                  printf("NOT the same %d) src1 = %d src2 = %d\n",lcv5,
                      (unsigned long) src1->color_datas[0]->color_indxs[lcv5],
                      (unsigned long) src2->color_datas[0]->color_indxs[lcv5]);
                  break;}
           if (lcv5 == src2->color_datas[0]->num_color_indxs)
              printf(" the same\n");
          }
     )

 PRT15(
       for (lcv1 = last1; lcv1 >= 0; lcv1--)
          if (src1->color_datas[lcv1]->scale.status & COLOR_LOCAL)
             printf("*** %d) src1 COLOR_LOCAL\n",lcv1);
            else printf("*** %d) src1 NON COLOR_LOCAL\n",lcv1);
       for (lcv1 = last2; lcv1 >= 0; lcv1--)
          if (src2->color_datas[lcv1]->scale.status & COLOR_LOCAL)
             printf("*** %d) src2 COLOR_LOCAL\n",lcv1);
            else printf("*** %d) src2 NON COLOR_LOCAL\n",lcv1);
      )
 PRT11(
       if ((vs1left < 0) || (vs1top < 0)) 
          printf("*** vs1left = %d vs1top = %d\n",vs1left,vs1top);
         else
          for (lcv1 = last1; lcv1 >= 0; lcv1--)
             if ((vs1right >= src1->color_datas[lcv1]->_2d.dimx) ||
                 (vs1bottom >= src1->color_datas[lcv1]->_2d.dimy))
                printf("*** %d) dimx = %d dimy = %d r = %d b = %d\n",
                     lcv1,src1->color_datas[lcv1]->_2d.dimx,
                     src1->color_datas[lcv1]->_2d.dimy,vs1right,vs1bottom);

       if ((vs2left < 0) || (vs2top < 0)) 
          printf("*** vs2left = %d vs2top = %d\n",vs2left,vs2top);
         else
          for (lcv2 = last2; lcv2>= 0; lcv2--)
             if ((vs2right >= src2->color_datas[lcv2]->_2d.dimx) ||
                 (vs2bottom >= src2->color_datas[lcv2]->_2d.dimy))
                printf("*** %d) dimx = %d dimy = %d r = %d b = %d\n",
                     lcv2,src2->color_datas[lcv2]->_2d.dimx,
                     src2->color_datas[lcv2]->_2d.dimy,vs2right,vs2bottom);
       )
***********************/


/*-------------------------------------------------------------------------
OrColorData - ???
-------------------------------------------------------------------------*/

int
OrColorData(dest,intensity,src1,dleft,dtop,dright,dbottom,dx,dy,
            src2,sleft,stop,sright,sbottom)
 struct buf_2d_rec *dest;
 struct intensity_rec *intensity;
 struct color_screen_rec *src1,*src2;
 long dleft,dtop,dright,dbottom,dx,dy,sleft,stop,sright,sbottom;
{
 struct buf_2d_rec *_2d;
 long dcol,scol,last1,last2,lcv2,lcv1,num;
 float fl;
 unsigned long val,val1,val2,val3;
 unsigned long x,y;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;
 struct color_rec *color;
 int err;

 PRT13(printf("\nOrColorData..src1 = %u src2 = %u\n",
         src1,src2))
 PRT11(printf("\nOrColorData..src1->num_color_datas = %d src2->num_color_datas = %d\n",
         src1->num_color_datas,src2->num_color_datas))
 PRT9(printf("..int label = %s num_scales = %d cur = %d\n",
     intensity->label,intensity->num_scales,intensity->cur_scale))
 if (dest->status4 & BUF_NON_EMPTY) dest->status4 &= ~BUF_DATA_VALID;
 if (((err = SetupColorScreenRecLocalScales(intensity,src1)) != NO_ERROR) ||
     ((err = SetupColorScreenRecLocalScales(intensity,src2)) != NO_ERROR))
    {TurnOffColorScreenRecNonLocalScales(src1);
     TurnOffColorScreenRecNonLocalScales(src2);
     return err;}
 if (ValidDstAndSrcBound(dleft,dtop,dright,dbottom,dx,dy,
       sleft,stop,sright,sbottom,
       &vs1left,&vs1top,&vs1right,&vs1bottom,&vs2left,&vs2top,&vs2right,&vs2bottom)
       != NO_ERROR)
    return NO_ERROR;
 PRT10(printf("\nOrColorData..\n"))
 PRT10(printf("dl = %d t = %d w = %d h = %d\n",vs1left,vs1top,
        vs1right - vs1left + 1,vs1bottom - vs1top + 1))
 PRT10(printf("sl = %d t = %d w = %d h = %d\n",vs2left,vs2top,
        vs2right - vs2left + 1,vs2bottom - vs2top + 1))
 PRT10(printf("OrColorData..\n\n"))

 if ((err = SetupBuf2dRecIfSmall(dest,
            vs1right - vs1left + 1,vs1bottom - vs1top + 1,
            src1->color_datas[0]->_2d.pixel_depth,0)) != NO_ERROR) 
    return err;
 color = &(intensity->color);
 Set2dStartOffsetXY(dest,vs1left,vs1top);
 last2 = src2->num_color_datas - 1;
 last1 = src1->num_color_datas - 1;
 PRT13(_2d = &(src1->color_datas[0]->_2d);
       printf("vs1 l = %d top = %d r = %d b = %d dimx = %d dimy = %d\n",
              vs1left,vs1top,vs1right,vs1bottom,_2d->dimx,_2d->dimy);)
 PRT13(_2d = &(src2->color_datas[0]->_2d);
       printf("vs2 l = %d top = %d r = %d b = %d dimx = %d dimy = %d\n",
              vs2left,vs2top,vs2right,vs2bottom,_2d->dimx,_2d->dimy))
 PRT12(cnt1 = cnt0 = cnt2 = cnt3 = cnt4 = cnt5 = cnt6 = cnt7 = cnt8 = cnt9 = 
        cnt10 = cnt11 = cnt12 = 0;)
 for (y = 0; vs1top <= vs1bottom; vs1top++,y++,vs2top++)
    for (x = 0,scol = vs2left,dcol = vs1left; 
               dcol <= vs1right; scol++,dcol++,x++)
        {PRT12(cnt0 += 1;)
         for (val1 = 0,lcv2 = last2; lcv2 >= 0; lcv2--)
            {_2d = &(src2->color_datas[lcv2]->_2d);
             if ((vs2top >= _2d->dimy) || (scol >= _2d->dimx)) continue;
             if (val1 = get_1d_buf_value(_2d->buf[vs2top],scol,_2d->pixel_depth))
                {val2 = val1;

                 if ((src2->color_datas[lcv2]->num_color_indxs > 0) &&
                     (val1 >= src2->color_datas[lcv2]->scale.first) &&
                     ((num = (val1 - src2->color_datas[lcv2]->scale.first)) < 
                              src2->color_datas[lcv2]->num_color_indxs))
                    {val1 = src2->color_datas[lcv2]->color_indxs[num];
                     PRT12(cnt7++;)}
                 break;}
            }
         if (lcv2 < 0)
            {val2 = val1;
             PRT12(cnt6++;)
             lcv2 = 0;}
         if ((val1 < color->total_colors) &&
             ((val1 == src2->color_datas[lcv2]->scale.first) ||
              (color->color_status[val1] & BACKGROUND_COLOR)))
            {set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,0);
             PRT12(cnt5++;)
            }
           else 
            {for (val = 0,lcv1 = last1; lcv1 >= 0; lcv1--)
                {_2d = &(src1->color_datas[lcv1]->_2d);
                 if ((vs1top >= _2d->dimy) || (dcol >= _2d->dimx)) continue;
                 if (val = get_1d_buf_value(_2d->buf[vs1top],dcol,_2d->pixel_depth))
                    {val3 = val;

                     if ((src1->color_datas[lcv1]->num_color_indxs > 0) &&
                         (val >= src1->color_datas[lcv1]->scale.first) &&
                         ((num = (val - src1->color_datas[lcv1]->scale.first)) < 
                              src1->color_datas[lcv1]->num_color_indxs))
                        val = src1->color_datas[lcv1]->color_indxs[num];
                     if ((val < color->total_colors) &&
                         ((val == src1->color_datas[lcv1]->scale.first) ||
                         (color->color_status[val] & BACKGROUND_COLOR)))
                        continue;
                     break;}
                }
             if (lcv1 < 0)
                {val3 = val;
                 PRT12(cnt2 += 1;)
                 lcv1 = 0;}
             if ((src2->color_datas[lcv2]->scale.first ==
                  src1->color_datas[lcv1]->scale.first) &&
                 (src2->color_datas[lcv2]->scale.num_colors ==
                  src1->color_datas[lcv1]->scale.num_colors))
                {if ((val < color->total_colors) &&
                     ((val == src1->color_datas[lcv1]->scale.first) ||
                     (color->color_status[val] & BACKGROUND_COLOR)))
                    {/*
                     if (src1->color_datas[lcv1]->scale.status & COLOR_LOCAL)
                        {
*/
                         val = GlobalToLocalColorIndx(
                                  &(src1->color_datas[lcv1]->scale),val1,
                                  src1->color_datas[lcv1]->color_indxs);
                         PRT12(cnt9++;)
/*
                        }
                        else
                        {val = val2;
                         PRT12(cnt8++;)}
*/
                    }
                   else /* if (src1->color_datas[lcv1]->scale.status & COLOR_LOCAL)*/
                    {val = (val1 + val) / 2;
                     val = GlobalToLocalColorIndx(
                                  &(src1->color_datas[lcv1]->scale),val,
                                  src1->color_datas[lcv1]->color_indxs);
                     PRT12(cnt10++;)}
/*
                   else
                    {val = (val2 + val3) / 2;
                     PRT12(cnt11++;)}
*/

                 PRT12(cnt1++;)
                }
               else if ((val < color->total_colors) &&
                        ((val == src1->color_datas[lcv1]->scale.first) ||
                        (color->color_status[val] & BACKGROUND_COLOR)))
                {
/*                 if (src2->color_datas[lcv2]->scale.status & COLOR_LOCAL)*/
                    val = val1;
                 /*  else val = val2;*/
                 PRT12(cnt3++;)
                }
               else
                {val -= src1->color_datas[lcv1]->scale.first;
                 fl = (float) src2->color_datas[lcv2]->scale.num_colors / 
                          (float) src1->color_datas[lcv1]->scale.num_colors;
                 fl = fl * (float) val;
                 if (fl >= (float) src2->color_datas[lcv2]->scale.num_colors)
                    val = src2->color_datas[lcv2]->scale.num_colors - 1 + 
                          src2->color_datas[lcv2]->scale.first;
                   else 
                    val = (unsigned long) rint((double) fl) + 
                          src2->color_datas[lcv2]->scale.first;
/*
                 if (src2->color_datas[lcv2]->scale.status & COLOR_LOCAL)
                    {val = (val1 + val) / 2;
                     PRT12(cnt12++;)
                    }
                   else
                    {*/
                     val = GlobalToLocalColorIndx(&(src2->color_datas[lcv2]->scale),val,
                                  src2->color_datas[lcv2]->color_indxs) + 
                            src2->color_datas[lcv2]->scale.first;
                     val = (val2 + val) / 2;
                     PRT12(cnt4++;)
/*
                    }
*/
                 }
             set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,val);
            }
        }
 PRT13(printf("OrColorData ...5\n"))
 dest->status4 |= BUF_DATA_VALID;
 TurnOffColorScreenRecNonLocalScales(src1);
 TurnOffColorScreenRecNonLocalScales(src2);
 PRT13(printf("OrColorData ...err = %d\n",err))
 PRT12(printf("OrColorData..cnt0 = %d cnt1 = %d cnt2 = %d cnt3 = %d cnt4 = %d  cnt5 = %d\n",
           cnt0,cnt1,cnt2,cnt3,cnt4,cnt5);
       printf("cnt6 = %d cnt7 = %d cnt8 = %d cnt9 = %d cnt10 = %d cnt11 = %d cnt12 = %d end\n\n",
               cnt6,cnt7,cnt8,cnt9,cnt10,cnt11,cnt12))
 return NO_ERROR;
}

/************************
SrcOnlyColorData(dest,intensity,src1,dleft,dtop,dright,dbottom,dx,dy,
                 src2,sleft,stop,sright,sbottom)
 struct buf_2d_rec *dest;
 struct intensity_rec *intensity;
 struct color_screen_rec *src1,*src2;
 long dleft,dtop,dright,dbottom,dx,dy,sleft,stop,sright,sbottom;
{
 struct buf_2d_rec *_2d;
 long dcol,scol,last2,lcv2,num;
 unsigned long val1,val2;
 unsigned long x,y;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;
 struct color_rec *color;
 int err,is_local_and_same_scale,is_src2_local;
 unsigned long cnt0,cnt1,cnt2,cnt3,cnt4;

 PRT13(printf("SrcOnlyColorData..src1 = %u  src2 = %u dest = %u\n",
    src1,src2,dest))
 if (dest->status4 & BUF_NON_EMPTY) dest->status4 &= ~BUF_DATA_VALID;
 if (((err = SetupColorScreenRecLocalScales(intensity,src1)) != NO_ERROR) ||
     ((err = SetupColorScreenRecLocalScales(intensity,src2)) != NO_ERROR))
    {TurnOffColorScreenRecNonLocalScales(src1);
     TurnOffColorScreenRecNonLocalScales(src2);
     PRT13(printf("SrcOnlyColorData...SetupColorScreenRecLocalScales err = %d\n",err))
     return err;}
 PRT13(printf("SrcOnlyColorData..src1->num_color_datas = %d src1->num_color_datas = %d\n",src1->num_color_datas,src2->num_color_datas))

 if (ValidDstAndSrcBound(dleft,dtop,dright,dbottom,dx,dy,
       sleft,stop,sright,sbottom,
       &vs1left,&vs1top,&vs1right,&vs1bottom,&vs2left,&vs2top,&vs2right,&vs2bottom)
       != NO_ERROR)
    return NO_ERROR;

 PRT9(printf("\nSrcOnlyColorData..dx = %d dy = %d\n",dx,dy))
 PRT9(printf("dleft = %d t = %d w = %d h = %d\n",dleft,dtop,
        dright - dleft + 1,dbottom - dtop + 1))
 PRT9(printf("sleft = %d t = %d w = %d h = %d\n",sleft,stop,
        sright - sleft + 1,sbottom - stop + 1))

 PRT9(printf("dl = %d t = %d w = %d h = %d\n",vs1left,vs1top,
        vs1right - vs1left + 1,vs1bottom - vs1top + 1))
 PRT9(printf("sl = %d t = %d w = %d h = %d\n",vs2left,vs2top,
        vs2right - vs2left + 1,vs2bottom - vs2top + 1))
 PRT9(printf("SrcOnlyColorData..\n\n"))

 PRT9(printf("SrcOnlyColorData...1..dest = %u src2 = %u\n",dest,src2))
 PRT9(printf("src2 color_datas = %u\n",src2->color_datas[0]))
 if ((err = SetupBuf2dRecIfSmall(dest,
            vs1right - vs1left + 1,vs1bottom - vs1top + 1,
            src2->color_datas[0]->_2d.pixel_depth,0)) != NO_ERROR) 
    return err;
 PRT9(printf("SrcOnlyColorData...src2 = %u\n",src2))
 if ((src1->num_color_datas > 0) &&
     (src1->color_datas[0] != NULL) &&
     (src2->num_color_datas > 0) &&
     (src2->color_datas[0] != NULL) &&
     (str_cmp(src1->color_datas[0]->scale.label,
              src2->color_datas[0]->scale.label) == 0))
    is_local_and_same_scale = 1;
   else is_local_and_same_scale = 0;
 if ((src2->num_color_datas > 0) &&
     (src2->color_datas[0] != NULL) &&
     (src2->color_datas[0]->scale.status & COLOR_LOCAL))
    is_src2_local = 1;
   else is_src2_local = 0;
 PRT13(printf("SrcOnlyColorData s1 is_local_and_same_scale = %d  is_src2_local= %d\n",
       is_local_and_same_scale,is_src2_local))
 PRT13(if (src1->num_color_datas > 0)
          {_2d = &(src1->color_datas[0]->_2d);
           printf("vs1 l = %d top = %d r = %d b = %d dimx = %d dimy = %d\n",
              vs1left,vs1top,vs1right,vs1bottom,_2d->dimx,_2d->dimy);}
      )
 PRT13(_2d = &(src2->color_datas[0]->_2d);
      printf("s2 l = %d top = %d r = %d b = %d dimx = %d dimy = %d\n",
              vs2left,vs2top,vs2right,vs2bottom,_2d->dimx,_2d->dimy);)
 color = &(intensity->color);
 last2 = src2->num_color_datas - 1;
 PRT13(cnt1 = cnt0 = cnt2 = cnt3 = cnt4 = 0;)
 for (y = 0; vs1top <= vs1bottom; vs1top++,y++,vs2top++)
    for (x = 0,scol = vs2left,dcol = vs1left; 
               dcol <= vs1right; scol++,dcol++,x++)
        {
         for (lcv2 = last2; lcv2 >= 0; lcv2--)
            {_2d = &(src2->color_datas[lcv2]->_2d);
             if ((vs2top >= _2d->dimy) || (scol >= _2d->dimx)) continue;
             if (val1 = get_1d_buf_value(_2d->buf[vs2top],scol,_2d->pixel_depth))
                {PRT13(cnt1 += 1)
                 val2 = val1;
                 if ((src2->color_datas[lcv2]->num_color_indxs > 0) &&
                     (val1 >= src2->color_datas[lcv2]->scale.first) &&
                     ((num = (val1 - src2->color_datas[lcv2]->scale.first)) < 
                              src2->color_datas[lcv2]->num_color_indxs))
                    {val1 = src2->color_datas[lcv2]->color_indxs[num];
                     if (is_local_and_same_scale && is_src2_local) val2 = val1;
                     PRT13(cnt2 += 1)
                    }

                 if ((val1 < color->total_colors) &&
                     ((val1 == src2->color_datas[lcv2]->scale.first) ||
                     (color->color_status[val1] & BACKGROUND_COLOR)))
                    {set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,0);
                     PRT13(cnt0 += 1)}
                   else if (is_local_and_same_scale)
                    {PRT13(cnt3 += 1)
                     val2 = GlobalToLocalColorIndx(&(src1->color_datas[0]->scale),val1,
                                  src1->color_datas[0]->color_indxs);
                     set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,val2);}
                   else
                    {PRT13(cnt4 += 1)
                     set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,val2);}
                 break;}
            }
        }
 dest->status4 |= BUF_DATA_VALID;
 TurnOffColorScreenRecNonLocalScales(src1);
 TurnOffColorScreenRecNonLocalScales(src2);
 PRT13(printf("SrcOnlyColorData..cnt0 = %d cnt1 = %d cnt2 = %d cnt3 = %d cnt4 = %d\n\n",
           cnt0,cnt1,cnt2,cnt3,cnt4);)
 return NO_ERROR;
}
***********************/


/*-------------------------------------------------------------------------
SrcOnlyColorData1 - ???
-------------------------------------------------------------------------*/

int
SrcOnlyColorData1(dest,intensity,src1,src2,sleft,stop,sright,sbottom)
 struct buf_2d_rec *dest;
 struct intensity_rec *intensity;
 struct color_screen_rec *src1,*src2;
 long sleft,stop,sright,sbottom;
{
 struct buf_2d_rec *_2d;
 long col,row,last2,lcv2,num,x,y;
 unsigned long val1,val2;
 struct color_rec *color;
 int err,is_local_and_same_scale,is_src2_local;

 PRT19(printf("SrcOnlyColorData..src1 = %u  src2 = %u dest = %u\n",
    src1,src2,dest))
 if (dest->status4 & BUF_NON_EMPTY) dest->status4 &= ~BUF_DATA_VALID;
 if (((err = SetupColorScreenRecLocalScales(intensity,src1)) != NO_ERROR) ||
     ((err = SetupColorScreenRecLocalScales(intensity,src2)) != NO_ERROR))
    {TurnOffColorScreenRecNonLocalScales(src1);
     TurnOffColorScreenRecNonLocalScales(src2);
     PRT13(printf("SrcOnlyColorData...SetupColorScreenRecLocalScales err = %d\n",err))
     return err;}
 PRT13(printf("SrcOnlyColorData..src1->num_color_datas = %d src1->num_color_datas = %d\n",src1->num_color_datas,src2->num_color_datas))

 if ((err = SetupBuf2dRecIfSmall(dest,
            sright - sleft + 1,sbottom - stop + 1,
            src2->color_datas[0]->_2d.pixel_depth,0)) != NO_ERROR) 
    return err;
 PRT13(printf("SrcOnlyColorData...dest\n"))
 PRT13(pr_buf_2d_rec(dest))
 if ((src1->num_color_datas > 0) &&
     (src1->color_datas[0] != NULL) &&
     (src2->num_color_datas > 0) &&
     (src2->color_datas[0] != NULL) &&
     (str_cmp(src1->color_datas[0]->scale.label,
              src2->color_datas[0]->scale.label) == 0))
    is_local_and_same_scale = 1;
   else is_local_and_same_scale = 0;
 if ((src2->num_color_datas > 0) &&
     (src2->color_datas[0] != NULL) &&
     (src2->color_datas[0]->scale.status & COLOR_LOCAL))
    is_src2_local = 1;
   else is_src2_local = 0;
 PRT13(printf("SrcOnlyColorData s1 is_local_and_same_scale = %d  is_src2_local= %d\n",
       is_local_and_same_scale,is_src2_local))
 color = &(intensity->color);
 Set2dStartOffsetXY(dest,0,0);
 last2 = src2->num_color_datas - 1;
 PRT13(cnt1 = cnt0 = cnt2 = cnt3 = cnt4 = 0;)
 for (row = stop,y = 0; row <= sbottom; row++,y++)
    for (x = 0,col = sleft;  col <= sright; col++,x++)
        {
         for (lcv2 = last2; lcv2 >= 0; lcv2--)
            {_2d = &(src2->color_datas[lcv2]->_2d);
             if (val1 = get_1d_buf_value(_2d->buf[row],col,_2d->pixel_depth))
                {PRT13(cnt1 += 1)
                 val2 = val1;
                 if ((src2->color_datas[lcv2]->num_color_indxs > 0) &&
                     (val1 >= src2->color_datas[lcv2]->scale.first) &&
                     ((num = (val1 - src2->color_datas[lcv2]->scale.first)) < 
                              src2->color_datas[lcv2]->num_color_indxs))
                    {val1 = src2->color_datas[lcv2]->color_indxs[num];
                     if (is_local_and_same_scale && is_src2_local) val2 = val1;
                     PRT13(cnt2 += 1)
                    }

                 if ((val1 < color->total_colors) &&
                     ((val1 == src2->color_datas[lcv2]->scale.first) ||
                     (color->color_status[val1] & BACKGROUND_COLOR)))
                    {set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,0);
                     PRT13(cnt0 += 1)}
                   else if (is_local_and_same_scale)
                    {PRT13(cnt3 += 1)
                     val2 = GlobalToLocalColorIndx(&(src1->color_datas[0]->scale),val1,
                                  src1->color_datas[0]->color_indxs);
                     set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,val2);}
                   else
                    {PRT13(cnt4 += 1)
                     set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,val2);}
                 break;}
            }
        }
 dest->status4 |= BUF_DATA_VALID;
 TurnOffColorScreenRecNonLocalScales(src1);
 TurnOffColorScreenRecNonLocalScales(src2);
 PRT13(printf("SrcOnlyColorData..cnt0 = %d cnt1 = %d cnt2 = %d cnt3 = %d cnt4 = %d\n\n",
           cnt0,cnt1,cnt2,cnt3,cnt4);)
 PRT19(printf("SrcOnlyColorData..end\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
BlendColorData - ???
-------------------------------------------------------------------------*/

int
BlendColorData(dest,intensity,src1,dleft,dtop,dright,dbottom,dx,dy,
               src2,sleft,stop,sright,sbottom,
               blend_select)
 struct buf_2d_rec *dest;
 struct intensity_rec *intensity;
 struct color_screen_rec *src1,*src2;
 long dleft,dtop,dright,dbottom,dx,dy,sleft,stop,sright,sbottom;
 int blend_select;
{
 struct buf_2d_rec *_2d;
 long dcol,scol,xsel,ysel,last1,last2,lcv2,lcv1,num,mod;
 unsigned long val1,val2;
 unsigned long x,y;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;
 struct color_rec *color;
 int err,yes;

 PRT11(printf("BlendColorData.blend_select = %d\n",blend_select))
 if (dest->status4 & BUF_NON_EMPTY) dest->status4 &= ~BUF_DATA_VALID;
 if (((err = SetupColorScreenRecLocalScales(intensity,src1)) != NO_ERROR) ||
     ((err = SetupColorScreenRecLocalScales(intensity,src2)) != NO_ERROR))
    {TurnOffColorScreenRecNonLocalScales(src1);
     TurnOffColorScreenRecNonLocalScales(src2);
     return err;}

 if (ValidDstAndSrcBound(dleft,dtop,dright,dbottom,dx,dy,
       sleft,stop,sright,sbottom,
       &vs1left,&vs1top,&vs1right,&vs1bottom,&vs2left,&vs2top,&vs2right,&vs2bottom)
       != NO_ERROR)
    return NO_ERROR;
 PRT(printf("dest..in\n");pr_buf_2d_rec(dest);)
 if ((err = SetupBuf2dRecIfSmall(dest,
            vs1right - vs1left + 1,vs1bottom - vs1top + 1,
            src1->color_datas[0]->_2d.pixel_depth,0)) != NO_ERROR) 
    return err;
 color = &(intensity->color);
 Set2dStartOffsetXY(dest,vs1left,vs1top);
 last2 = src2->num_color_datas - 1;
 last1 = src1->num_color_datas - 1;
 PRT(printf("dest..out\n");pr_buf_2d_rec(dest);)
 PRT11(printf("vs2left = %d vs2top = %d vs2right = %d vs2bottom = %d\n",
    vs2left,vs2top,vs2right,vs2bottom))
 PRT11(printf("vs1left = %d vs1top = %d vs1right = %d vs1bottom = %d\n",
    vs1left,vs1top,vs1right,vs1bottom))

 PRT11(
       if ((vs1left < 0) || (vs1top < 0)) 
          printf("*** vs1left = %d vs1top = %d\n",vs1left,vs1top);
         else
          for (lcv1 = last1; lcv1 >= 0; lcv1--)
             if ((vs1right >= src1->color_datas[lcv1]->_2d.dimx) ||
                 (vs1bottom >= src1->color_datas[lcv1]->_2d.dimy))
                printf("*** %d) dimx = %d dimy = %d r = %d b = %d\n",
                     lcv1,src1->color_datas[lcv1]->_2d.dimx,
                     src1->color_datas[lcv1]->_2d.dimy,vs1right,vs1bottom);

       if ((vs2left < 0) || (vs2top < 0)) 
          printf("*** vs2left = %d vs2top = %d\n",vs2left,vs2top);
         else
          for (lcv2 = last2; lcv2>= 0; lcv2--)
             if ((vs2right >= src2->color_datas[lcv2]->_2d.dimx) ||
                 (vs2bottom >= src2->color_datas[lcv2]->_2d.dimy))
                printf("*** %d) dimx = %d dimy = %d r = %d b = %d\n",
                     lcv2,src2->color_datas[lcv2]->_2d.dimx,
                     src2->color_datas[lcv2]->_2d.dimy,vs2right,vs2bottom);
       )
 mod = blend_select * 2;
 for (y = 0; vs1top <= vs1bottom; vs1top++,y++,vs2top++)
    {ysel = vs1top % mod;
     for (x = 0,scol = vs2left,dcol = vs1left;
                  dcol <= vs1right; scol++,dcol++,x++)
        {xsel = dcol % mod;
         if (((ysel < blend_select) && (xsel >= blend_select)) ||
             (xsel < blend_select))
            {
             for (yes = 1,lcv1 = last1; lcv1 >= 0; lcv1--)
                {_2d = &(src1->color_datas[lcv1]->_2d);
                 if ((vs1top >= _2d->dimy) || (dcol >= _2d->dimx)) continue;
                 if (val1 = get_1d_buf_value(_2d->buf[vs1top],dcol,
                            _2d->pixel_depth))
                    {
                     if ((src1->color_datas[lcv1]->num_color_indxs > 0) &&
                         (val1 >= src1->color_datas[lcv1]->scale.first) &&
                         ((num = (val1 - src1->color_datas[lcv1]->scale.first)) < 
                              src1->color_datas[lcv1]->num_color_indxs))
                        val1 = src1->color_datas[lcv1]->color_indxs[num];

                     if ((val1 < color->total_colors) &&
                         ((val1 == src1->color_datas[lcv1]->scale.first) ||
                          (color->color_status[val1] & BACKGROUND_COLOR)))
                        yes = 0;
                     break;}
                }
             if (yes)
                {set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,0);
                 continue;}
            }

         for (lcv2 = last2; lcv2 >= 0; lcv2--)
            {_2d = &(src2->color_datas[lcv2]->_2d);
             if ((vs2top >= _2d->dimy) || (scol >= _2d->dimx)) continue;
             if (val1 = get_1d_buf_value(_2d->buf[vs2top],scol,_2d->pixel_depth))
                {val2 = val1;
                 if ((src2->color_datas[lcv2]->num_color_indxs > 0) &&
                     (val1 >= src2->color_datas[lcv2]->scale.first) &&
                     ((num = (val1 - src2->color_datas[lcv2]->scale.first)) < 
                              src2->color_datas[lcv2]->num_color_indxs))
                    {
                     val1 = src2->color_datas[lcv2]->color_indxs[num];
                     if ((lcv2 != 0) && (val1 < color->total_colors) &&
                         ((val1 == src2->color_datas[lcv2]->scale.first) ||
                         (color->color_status[val1] & BACKGROUND_COLOR)))
                        continue;
                    }
                 break;}
            }
         if ((val1 < color->total_colors) &&
             ((val1 == src2->color_datas[lcv2]->scale.first) ||
              (color->color_status[val1] & BACKGROUND_COLOR)))
            {set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,0);}
           else set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,val2);
        }
    }

 PRT11(printf("BlendColorData..end\n"))
 dest->status4 |= BUF_DATA_VALID;
 TurnOffColorScreenRecNonLocalScales(src1);
 TurnOffColorScreenRecNonLocalScales(src2);
 PRT7(printf("BlendColorData..end\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinFusionIt - ???
-------------------------------------------------------------------------*/

int
WinFusionIt(win,dest,dst_bound,src1,src2,src2_bound,method)
 struct image_display_window *win;
 struct buf_2d_rec *dest;
 struct color_screen_rec *src1,*src2;
 struct int_bound_rec *dst_bound,*src2_bound;
 unsigned long method;
{
 int err;
 struct buf_2d_rec *_2d;
 struct int_bound_rec *bound;
 struct img_buf_rec *img;
 long vs1left,vs1top,vs1right,vs1bottom;

 _2d = &(src1->color_datas[0]->_2d);
 PRT13(printf("WinFusionIt....method = %x\n",method))
 PRT11(printf("WinFusionIt....\n");
       pr_int_bound_rec(dst_bound))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (method & METHOD_BLEND_SUPERIMPOSE)
    {
     err = OrColorData(dest,win->intensity,src1,
         0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
         dst_bound->left,dst_bound->top,
         src2,src2_bound->left,src2_bound->top,
         src2_bound->right,src2_bound->bottom);
    }
   else if (method & METHOD_BLEND_3_BY_3)
    err = BlendColorData(dest,win->intensity,src1,
         0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
         dst_bound->left,dst_bound->top,
         src2,src2_bound->left,src2_bound->top,
         src2_bound->right,src2_bound->bottom,3);
   else if (method & METHOD_BLEND_6_BY_6)
    err = BlendColorData(dest,win->intensity,src1,
         0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
         dst_bound->left,dst_bound->top,
         src2,src2_bound->left,src2_bound->top,
         src2_bound->right,src2_bound->bottom,6);
   else if (method & METHOD_BLEND_9_BY_9)
    err = BlendColorData(dest,win->intensity,src1,
         0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
         dst_bound->left,dst_bound->top,
         src2,src2_bound->left,src2_bound->top,
         src2_bound->right,src2_bound->bottom,9);

 PRT13(printf("WinFusionIt....end...err = %d\n",err))
 if (err == NO_ERROR)
    {dest->status4 |= BUF_DATA_VALID;
     bound = &(img->_2d_fusion.src_screen_bound);
     if (ValidDstAndSrcBound(
           0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
           dst_bound->left,dst_bound->top,
           src2_bound->left,src2_bound->top,src2_bound->right,src2_bound->bottom,
           &vs1left,&vs1top,&vs1right,&vs1bottom,
         &(bound->left),&(bound->top),&(bound->right),&(bound->bottom)) != NO_ERROR)
        {
         return CANCEL;}
    }
   else dest->status4 &= ~BUF_DATA_VALID;
 return err;
}


/*-------------------------------------------------------------------------
WinDynamicForwardFusion1 - ???
-------------------------------------------------------------------------*/

int
WinDynamicForwardFusion1(win,has_been_transformed)
 struct image_display_window *win;
 int has_been_transformed;
{
 struct img_buf_rec *img,*img1;
 struct image_display_window *win1;
 struct win_rec *rwin;
 struct sel_buf_2d_rec *sel_2d;
 struct buf_2d_rec *_2d;
 struct int_bound_rec *src_bound,*dst_bound;
 struct color_data_rec *new_color_data;
 int err;
 struct color_screen_rec *src;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NO_ERROR;
 PRT19(printf("\nWinDynamicForwardFusion..src_wid = %s\n",img->src_wid))
 if (((rwin = get_win_rec_by_wid_str(img->win,img->src_wid)) != NULL) &&
     ((img1 = win_rec_cur_img_buf(rwin)) != NULL) &&
     ((win1 = rwin->image_display) != NULL))
    {PRT19(printf("WinDynamicForwardFusion..src_wid = %s\n",img->src_wid))
     if (img->_2d_fusion.status & FUSION_SYNC)
        if (!(img->_2d_fusion.status & FUSION_BACKWARD_READY))
           {img->_2d_fusion.status |= FUSION_FORWARD_READY;
            img->status4 &= ~IMAGE_2D_SUPERIMPOSED_READY;
            img->status4 |= IMAGE_2D_SUPERIMPOSED_READY_SAVED;
            PRT8(printf("done FUSION_FORWARD_READY...src_wid = %s\n",img->src_wid));
            return NO_ERROR;}
     if (img->status4 & IMG_REDEFINE_FUSION_PARAMS)
        {img->status4 &= ~IMG_REDEFINE_FUSION_PARAMS;
         win_redefine_fusion_bounds(win,win1,img->src_wid);}

     sel_2d = &(img->_2d_fusion);
     src_bound = &(sel_2d->src_bound);
     dst_bound = &(sel_2d->dst_bound);
/*
     if (!(sel_2d->status & FUSION_ACCUMULATED))
        win_clear_last_2d_fusion(win);
*/
     PRT16(
           printf("\ndst_bound dl = %d dt = %d  dr = %d db = %d\n",
             dst_bound->left,dst_bound->top,dst_bound->right,dst_bound->bottom))
     WinEnableDisableColorData(win,SUPERIMPOSE_ID,1);
     if (sel_2d->src_trans_unit.status2 & UNIT_2D_IN_USE)
        {PRT18(printf("WinDynamicForwardFusion TransformFusionSrc\n"))
         if (!has_been_transformed)
            if ((err = TransformFusionSrc(img)) != NO_ERROR) return err;
         src = &(sel_2d->trans_src);}
       else src = &(sel_2d->src);
     if ((err = WinFusionIt(win,&(sel_2d->_2d),dst_bound,
               &(win->data),src,src_bound,
               (unsigned long) sel_2d->status)) == NO_ERROR)
        {sel_2d->status &= ~FUSION_NEXT_CLEAR_STATUS;
         sel_2d->status &= ~FUSION_CLEAR_SYNC;
         PRT9(printf("WinDynamicForwardFusion ...WinSetupColorDataRec win status = %x\n\n",win->status4);)
         PRT9(printf("_2d.startoffx = %d _2d.startoffy = %d\n",
                       sel_2d->_2d.startoffx,sel_2d->_2d.startoffy);)
         if ((err = WinSetupColorDataRec2(win,0,SUPERIMPOSE_ID,0,0,0,0,
                    sel_2d->_2d.pixel_depth,0,&new_color_data,0)) == NO_ERROR)
            {_2d = &(new_color_data->_2d);
             InitBuf2dRecData(_2d,(double) .0);
             PRT19(printf("WinDynamicForwardFusion sel_2d dimx = %d dimy = %d offx = %d offy = %d l = %d t = %d\n",
                  sel_2d->_2d.dimx,sel_2d->_2d.dimy,
                  sel_2d->_2d.startoffx,sel_2d->_2d.startoffy,
                  sel_2d->dst_bound.left,sel_2d->dst_bound.top);)
             PRT19(printf("....new_color_data = %u _2d dimx = %d dimy = %d\n",
                 new_color_data,_2d->dimx,_2d->dimy))
             Set2dStartOffsetXY(_2d,0,0);
             Cp2dByBound(_2d,0,0,_2d->dimx - 1,_2d->dimy - 1,
                      0,0,
                      &(sel_2d->_2d),0,0,                               
                      sel_2d->_2d.dimx - 1,
                      sel_2d->_2d.dimy - 1,4,
                      (double) .0,(double) 0,0);
             Set2dStartOffsetXY(_2d,sel_2d->_2d.startoffx,sel_2d->_2d.startoffy);
             PRT10(MinMax2dValues(_2d,0,(double) .0,(double) .0,&min4,&max4);
                printf(" _2d min4 = %f max4 = %f\n",min4,max4))

             img->_2d_fusion.status |= FUSION_MOVE_UPDATE;
             PRT9(printf("WinDynamicForwardFusion 2d updated\n"))
            }
           else err = CANCEL;
        }
    }
   else return NO_ERROR;
 PRT19(printf("WinDynamicForwardFusion..err = %d num_color_datas = %d\n",err,
           win->data.num_color_datas))
 return err;
}


/*-------------------------------------------------------------------------
WinDynamicBackwardFusion - ???
-------------------------------------------------------------------------*/

int
WinDynamicBackwardFusion(win)
 struct image_display_window *win;
{
 int err;
 struct img_buf_rec *img,*img1;
 struct image_display_window *win1;
 struct win_rec *rwin;
 long lcv;
 char *cur_wid;
 struct sel_buf_2d_rec *sel_2d;
 struct buf_2d_rec *_2d;
 struct int_bound_rec *src_bound,*dst_bound;
 struct color_data_rec *new_color_data;
 struct color_screen_rec *src;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (img->num_dst_wids == 0) return NO_ERROR;
 cur_wid = WinRecGetWid(win->owner,win->type2);
 PRT16(printf("\nWinDynamicBackwardFusion...num_dst_wids = %d\n",img->num_dst_wids))
 for (lcv = 0; lcv < img->num_dst_wids; lcv++)
    if (((rwin = get_win_rec_by_wid_str(img->win,img->dst_wids[lcv])) != NULL) &&
        ((img1 = win_rec_cur_img_buf(rwin)) != NULL) &&
        ((win1 = rwin->image_display) != NULL))
       {PRT16(printf("cur_wid = %s rwin->wid = %s img1->src_wid = %s\n",
                cur_wid,rwin->wid,img1->src_wid))
        if ((img1->_2d_fusion.status & FUSION_METHOD) &&
            (str_cmp(cur_wid,img1->src_wid) == 0))
           {PRT14(printf("WinDynamicBackwardFusion...2\n"))
            sel_2d = &(img1->_2d_fusion);
            sel_2d->status |= FUSION_MOVE_UPDATE;

            if ((err = cp_color_screen_rec(&(img1->_2d_fusion.src),
                        &(win->data),0,0,0)) != NO_ERROR)
               return err;
            if (sel_2d->src_trans_unit.status2 & UNIT_2D_IN_USE)
               {PRT18(printf("WinDynamicBackward TransformFusionSrc\n"))
                if (((err = cp_color_screen_rec(&(img1->_2d_fusion.trans_src),
                        &(img1->_2d_fusion.src),0,0,0)) != NO_ERROR) ||
                    ((err = TransformFusionSrc(img1)) != NO_ERROR))
                   return err;
                src = &(img1->_2d_fusion.trans_src);
               }
              else src = &(img1->_2d_fusion.src);
            src_bound = &(sel_2d->src_bound);
            dst_bound = &(sel_2d->dst_bound);
            if ((err = SrcOnlyColorData1(&(sel_2d->srcindst_2d),win->intensity,
                 &(win1->data),src,
                 src_bound->left,src_bound->top,src_bound->right,src_bound->bottom))
                   != NO_ERROR)
               return err;
            if (img1->_2d_fusion.status & FUSION_SYNC)
               {PRT16(printf("WinDynamicBackwardFusion...FUSION_SYNC..wait\n"))
                if (!(img1->_2d_fusion.status & FUSION_FORWARD_READY))
                   {img1->_2d_fusion.status |= FUSION_BACKWARD_READY;
                    img->_2d_fusion.status |= FUSION_MUST_RECOMPUTE;
                    PRT6(printf(" not FUSION_BACKWARD_READY...%s\n",img1->src_wid));
                    continue;}
               }
            if (img1->status4 & IMAGE_2D_SUPERIMPOSED_READY_SAVED) 
               {img1->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
                img1->status4 &= ~IMAGE_2D_SUPERIMPOSED_READY_SAVED;}

            if (!(img1->status4 & IMAGE_2D_SUPERIMPOSED_READY))
               {img->_2d_fusion.status |= FUSION_MUST_RECOMPUTE;
                img->_2d_fusion.status |= FUSION_BACKWARD_READY;
                PRT6(printf(" 2 FUSION_BACKWARD_READY...%s\n",img1->src_wid));
                return NO_ERROR;}

            if (img1->status4 & IMG_REDEFINE_FUSION_PARAMS)
               {img1->status4 &= ~IMG_REDEFINE_FUSION_PARAMS;
                win_redefine_fusion_bounds(win1,win,img1->src_wid);}

            WinEnableDisableColorData(win1,SUPERIMPOSE_ID,1);
            if ((err = WinFusionIt(win1,&(sel_2d->_2d),dst_bound,
                  &(win1->data),src/*&(win->data)*/,src_bound,
                  (unsigned long) sel_2d->status)) == NO_ERROR)
               {sel_2d->status &= ~FUSION_NEXT_CLEAR_STATUS;
                sel_2d->status &= ~FUSION_CLEAR_SYNC;}

            PRT9(printf("\nWinDynamicBackward SetupColorDataRec wid = %s...4.err = %d  status = %x\n",img->dst_wids[lcv],err,win1->status4))
            PRT9(printf("_2d.startoffx = %d _2d.startoffy = %d\n",
                       sel_2d->_2d.startoffx,sel_2d->_2d.startoffy);)

            /*win1->status4 |= WIN_COLOR_DATA_UNCHANGED;*/
            if ((err = WinSetupColorDataRec2(win1,0,SUPERIMPOSE_ID,0,0,0,0,
                    sel_2d->_2d.pixel_depth,0,&new_color_data,0)) == NO_ERROR)
               {_2d = &(new_color_data->_2d);
                InitBuf2dRecData(_2d,(double) .0);
                PRT16(printf("WinDynamicBackwardFusion sel_2d dimx = %d dimy = %d offx = %d offy = %d l = %d t = %d\n",
                  sel_2d->_2d.dimx,sel_2d->_2d.dimy,
                  sel_2d->_2d.startoffx,sel_2d->_2d.startoffy,
                  sel_2d->dst_bound.left,sel_2d->dst_bound.top);)
                PRT16(printf("...._2d dimx = %d dimy = %d\n",_2d->dimx,_2d->dimy))
                Set2dStartOffsetXY(_2d,0,0);
                Cp2dByBound(_2d,0,0,_2d->dimx - 1,_2d->dimy - 1,
                      0,0,
                      &(sel_2d->_2d),0,0,                               
                      sel_2d->_2d.dimx - 1,
                      sel_2d->_2d.dimy - 1,4,
                      (double) .0,(double) 0,0);
                Set2dStartOffsetXY(_2d,sel_2d->_2d.startoffx,sel_2d->_2d.startoffy);
                img1->_2d_fusion.status |= FUSION_MOVE_UPDATE;
                WinMultiScreenCanvas(win1);}
            PRT7(printf("\n\nWinDynamicBackwardFusion err = %d\n",err))
           }
          else 
           {PRT(printf("WinDynamicBackwardFusion..3 drop = %s\n",img->dst_wids[lcv]))
            drop_img_dst_wids(img,img->dst_wids[lcv]);}
       }
      else
       {PRT7(printf("WinDynamicBackwardFusion..4 drop = %s\n",img->dst_wids[lcv]))
        drop_img_dst_wids(img,img->dst_wids[lcv]);}
 PRT18(printf("WinDynamicBackwardFusion..done NO_ERROR\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinMoveFusion2dToSuperimpose2d - ???
-------------------------------------------------------------------------*/

int
WinMoveFusion2dToSuperimpose2d(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct color_data_rec *new_color_data;
 struct buf_2d_rec *_2d;
 int err;

 PRT19(printf("WinMoveFusion2dToSuperimpose2d...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((err = WinSetupColorDataRec2(win,0,SUPERIMPOSE_ID,0,0,0,0,
                img->_2d_fusion._2d.pixel_depth,0,&new_color_data,0)) == NO_ERROR)
   {
    PRT19(printf("WinMoveFusion2dToSuperimpose2d....new_color_data = %d\n",new_color_data))
    _2d = &(new_color_data->_2d);
    InitBuf2dRecData(_2d,(double) .0);
         PRT16(printf("WinMoveFusion2dToSuperimpose2d sel_2d dimx = %d dimy = %d offx = %d offy = %d l = %d t = %d\n",
                  img->_2d_fusion._2d.dimx,img->_2d_fusion._2d.dimy,
                  img->_2d_fusion._2d.startoffx,img->_2d_fusion._2d.startoffy,
                  img->_2d_fusion.dst_bound.left,img->_2d_fusion.dst_bound.top);)

    PRT16(printf("...._2d dimx = %d dimy = %d\n",_2d->dimx,_2d->dimy))
    Set2dStartOffsetXY(_2d,0,0);
    Cp2dByBound(_2d,0,0,_2d->dimx - 1,_2d->dimy - 1,
                      0,0,
                      &(img->_2d_fusion._2d),0,0,                               
                      img->_2d_fusion._2d.dimx - 1,
                      img->_2d_fusion._2d.dimy - 1,4,
                      (double) .0,(double) 0,0);
    Set2dStartOffsetXY(_2d,img->_2d_fusion._2d.startoffx,
                 img->_2d_fusion._2d.startoffy);
    PRT10(MinMax2dValues(_2d,0,(double) .0,(double) .0,&min4,&max4);
                printf(" _2d min4 = %f max4 = %f\n",min4,max4))

    img->_2d_fusion.status |= FUSION_MOVE_UPDATE;
   }
 PRT19(printf("WinMoveFusion2dToSuperimpose2d...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
WinImageFusion1 - ???
-------------------------------------------------------------------------*/

int
WinImageFusion1(win,src_bound,dst_bound,opr,src_wid)
 struct image_display_window *win;
 struct int_bound_rec *src_bound,*dst_bound;
 int opr;
 char *src_wid;
{
 struct img_buf_rec *img,*img1;
 struct image_display_window *win1;
 struct win_rec *rwin;
 int err;
 unsigned long method;

 PRT13(printf("WinImageFusion...src_wid = %s\n",src_wid))
 PRT1(printf("...dst_bound\n");pr_int_bound_rec(dst_bound);)
 PRT1(printf("...src_bound\n");pr_int_bound_rec(src_bound);)
 PRT1(printf("...opr = %d\n",opr);)

 method = fusion_method(opr);
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (((rwin = get_win_rec_by_wid_str(img->win,src_wid)) == NULL) ||
     ((img1 = win_rec_cur_img_buf(rwin)) == NULL) ||
     ((win1 = rwin->image_display) == NULL))
    return CANCEL;
 PRT17(printf("WinImageFusion...cp_color_screen_rec\n"))
 if ((err = cp_color_screen_rec(&(img->_2d_fusion.src),&(win1->data),0,0,0)) != NO_ERROR)
    return err;
 initial_unit_2d_rec(&(img->_2d_fusion.src_trans_unit));
 PRT17(printf("WinImageFusion...after cp_color_screen_rec\n"))
/*
 if (!(img->_2d_fusion.status & FUSION_ACCUMULATED))
    win_clear_last_2d_fusion(win);
*/
 WinEnableDisableColorData(win,SUPERIMPOSE_ID,1);
 PRT13(printf("WinImageFusion...0\n"))
/*
 if ((err = SrcOnlyColorData(&(img->_2d_fusion.srcindst_2d),win1->intensity,
             &(win->data),
             0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
             img->_2d_fusion.def_dst_left,img->_2d_fusion.def_dst_top,
             &(img->_2d_fusion.src),
             src_bound->left,src_bound->top,src_bound->right,src_bound->bottom))
                == NO_ERROR)
*/
 if ((err = SrcOnlyColorData1(&(img->_2d_fusion.srcindst_2d),win1->intensity,
             &(win->data),&(img->_2d_fusion.src),
             src_bound->left,src_bound->top,src_bound->right,src_bound->bottom))
                == NO_ERROR)
     err = WinFusionIt(win,&(img->_2d_fusion._2d),dst_bound,
         &(win->data),&(img->_2d_fusion.src)/*&(win1->data)*/,src_bound,
         method);
 PRT13(printf("WinImageFusion....1...\n"))
 if (err == NO_ERROR)
    {
     img->_2d_fusion.dst_bound = *dst_bound;
     img->_2d_fusion.src_bound = *src_bound;
     img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
     img->_2d_fusion.status &= ~FUSION_NEW_CLEAR_STATUS;
     img->_2d_fusion.status |= method;

     img->_2d_fusion._2d.status4 |= BUF_DATA_VALID;
     PRT13(printf("WinImageFusion....2...\n"))
     if (str_cmp(img->src_wid,src_wid) != 0)
        {if (img->src_wid != NULL) win_add_or_drop_dynamic_fusion(win,0);
         img->_2d_fusion.status |= FUSION_MOVE_UPDATE;
         str_dealloc_and_cpy(&(img->src_wid),src_wid);}
     PRT13(printf("WinImageFusion....3...\n"))
     if ((err = WinMoveFusion2dToSuperimpose2d(win)) == NO_ERROR)
        WinMultiScreenCanvas(win);
     PRT13(printf("WinImageFusion....6...\n"))
    }
 return err;
}


/*-------------------------------------------------------------------------
TransformFusionSrc - ???
-------------------------------------------------------------------------*/

int
TransformFusionSrc(img)
 struct img_buf_rec *img;
{
 int err;
 unsigned long lcv;
 struct sel_buf_2d_rec *_2d_fusion;

 _2d_fusion = &(img->_2d_fusion);
 PRT18(printf("TransformFusionSrc src.num_color_datas = %d  trans_src num_color_datas = %d\n",
      _2d_fusion->src.num_color_datas,_2d_fusion->trans_src.num_color_datas))
 if (_2d_fusion->src.num_color_datas != _2d_fusion->trans_src.num_color_datas)
    return CANCEL;
 for (lcv = 0; lcv < _2d_fusion->src.num_color_datas; lcv++)
    {
     if ((err = ResizeBuf2dRec(&(_2d_fusion->trans_src.color_datas[lcv]->_2d),
               &(_2d_fusion->src.color_datas[lcv]->_2d),
               _2d_fusion->src.color_datas[lcv]->_2d.dimx,
               _2d_fusion->src.color_datas[lcv]->_2d.dimy,
                &(_2d_fusion->src_trans_unit.tolocal_mat))) != NO_ERROR)
        {PRT18(printf("TransformFusionSrc %d) err = %d\n",lcv,err))
         return err;
        }
    }
 PRT18(printf("TransformFusionSrc NO_ERROR\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinRotateFusion - ???
-------------------------------------------------------------------------*/

int
WinRotateFusion(win,fl_angle)
 struct image_display_window *win;
 float fl_angle;
{
 struct unit_2d_rec old,mat;
 struct img_buf_rec *img;
 struct sel_buf_2d_rec *_2d_fusion;
 double rad;
 float centerx,centery;
 int err;
 unsigned long dimx,dimy;

 PRT18(printf("WinRotateFusion fl_angle = %f\n",fl_angle))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 set_win_busy(win);
_2d_fusion = &(img->_2d_fusion);
 PRT18(printf("WinRotateFusion src.num_color_datas = %d  trans_src num_color_datas = %d\n",
      _2d_fusion->src.num_color_datas,_2d_fusion->trans_src.num_color_datas))
 if (_2d_fusion->src.num_color_datas <= 0) return CANCEL;
 if (_2d_fusion->src.num_color_datas != _2d_fusion->trans_src.num_color_datas)
   {PRT18(printf("WinRotateFusion cp_color_screen_rec.,..\n"))
    if ((err = cp_color_screen_rec(&(_2d_fusion->trans_src),
                        &(_2d_fusion->src),0,0,0)) != NO_ERROR)
       {set_win_not_busy(win);
        return err;}
   }
 old = img->_2d_fusion.src_trans_unit;
 dimx = _2d_fusion->src.bound.right - _2d_fusion->src.bound.left + 1;
 dimy = _2d_fusion->src.bound.bottom - _2d_fusion->src.bound.top + 1;
 if (!(_2d_fusion->src_trans_unit.status2 & UNIT_2D_IN_USE))
    {PRT18(printf("WinRotateFusion not UNIT_2D_IN_USE\n"))
     setup_unit_2d_rec(&(_2d_fusion->src_trans_unit),
            .0,.0,1.0,1.0,dimx,dimy,
            .0,.0,1.0,1.0);
    }
 rad = radian(fl_angle);
 centerx = (float) (dimx - 1) / 2.0;
 centery = (float) (dimy - 1) / 2.0;
 setup_rotate_2d_matrix_from_xy(&mat,rad,centerx,centery);
 PRT18(printf("WinRotateFusion dst_bound l = %d t = %d\n",
                  _2d_fusion->dst_bound.left,_2d_fusion->dst_bound.top);)
 mult_2d_matrix(&(_2d_fusion->src_trans_unit.localto_mat),
         &mat,&(_2d_fusion->src_trans_unit.localto_mat));
 inverse_2d_matrix(&(_2d_fusion->src_trans_unit.tolocal_mat),
                   &(_2d_fusion->src_trans_unit.localto_mat));
 PRT18(printf("dimx = %d dimy = %d...centerx = %f centery = %f\n",dimx,dimy,centerx,centery);)
 PRT18(printf("tolocal_mat...\n");pr_2d_matrix(&(_2d_fusion->src_trans_unit.tolocal_mat)))
 PRT18(printf("localto_mat...\n");pr_2d_matrix(&(_2d_fusion->src_trans_unit.localto_mat)))
 
 if ((err = TransformFusionSrc(img)) == NO_ERROR)
    {
     if ((err = SrcOnlyColorData1(&(_2d_fusion->srcindst_2d),win->intensity,
             &(win->data),&(_2d_fusion->trans_src),
             _2d_fusion->src_bound.left,_2d_fusion->src_bound.top,
             _2d_fusion->src_bound.right,_2d_fusion->src_bound.bottom))
           == NO_ERROR)
       {
        err = WinDynamicForwardFusion1(win,1);
        WinMultiScreenCanvas(win);}
    }
 PRT18(printf("WinRotateFusion  err = %d\n",err))
 set_win_not_busy(win);
 return err;
}

