/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

#ifndef ERROR_CONSTANTS_H
#define	ERROR_CONSTANTS_H

#define NO_ERROR 0
#define NOT_ENOUGH_MEMORY 1
#define CANNOT_ALLOCATE_ALL_BUFFERS 2
#define INDEX_OUT_OF_RANGE 3
#define CANCEL 4
#define ABORT 5
#define READ_ERROR -1
#define WRITE_ERROR -2
#define FILE_ACCESS_ERROR -3
#define FILE_NAME_ERROR -4
#define BAD_DATA -5
#define ILLEGAL_FILE_ADDRESS -6
#define END_OF_FILE -6
#define NOT_FOUND -10   /* MUST BE A NEGATIVE # */
#define FILE_ALREADY_OPEN -11   /* MUST BE A NEGATIVE # */
#define WINDOW_ERROR -100

#define FILE_READ_ACCESS_ERROR -12
#define FILE_READ_HDR_ERROR -13
#define FOUND -14   /* MUST BE A NEGATIVE # */
#define BAD_VERSION -15   /*  */
#define FILE_NOT_EXIST -16
#define NOT_ENOUGH_HARD_DISK -17
#define PROGRAM_ERROR -99     /* Known but unfixed bug in program */
#define NOT_ENOUGH_DISK_MEMORY -1000  /* junk, to prevent error in make */
				/* Last #define only used in tape1/system_specific.c */
#endif ERROR_CONSTANTS_H


